/* src/main.c - Fichier principal
 * Copyright (C) 2002-2003 Inter System
 *
 * contact: Progs@Inter-System.Net
 *          Cesar@Inter-System.Net
 *          kouak@kouak.org
 * site web: http://coderz.inter-system.net
 *
 * Services pour serveur IRC. Support sur IrcProgs et IrCoderZ
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <unistd.h>
#include <signal.h>
#define GLOBALS_DEF
#include "main.h"
#undef GLOBALS_DEF
#ifdef TESTBOT
#include "web2cs.h"
#endif

extern void run_bot(int);
extern int init_bot(int, int);
extern int register_user(aNick *, aChan *, int, char **);
extern int drop_user(aNick *, aChan *, int, char **);
extern int showcommands(aNick *, aChan *, int, char **);
extern int uptime(aNick *, aChan *, int, char **);
extern int ns_login(aNick *, aChan *, int, char **);
extern int ctcp_ping(aNick *, aChan *, int, char **);
extern int ctcp_version(aNick *, aChan *, int, char **);
extern int die(aNick *, aChan *, int, char **);
#ifdef USE_MEMOSERV
extern int memos(aNick *, aChan *, int, char **);
#endif
extern int inviteme(aNick *, aChan *, int, char **);
extern int show_admins(aNick *, aChan *, int, char **);
extern int aide(aNick *, aChan *, int, char **);
extern int register_chan(aNick *, aChan *, int, char **);
extern int unreg_chan(aNick *, aChan *, int, char **);
extern int list_badchans(aNick *, aChan *, int, char **);
extern int show_access(aNick *, aChan *, int, char **);
extern int admin_level(aNick *, aChan *, int, char **);
extern int set_welcome(aNick *, aChan *, int, char **);
extern int list_badnicks(aNick *, aChan *, int, char **);
extern int cs_whois(aNick *, aChan *, int, char **);
extern int add_user(aNick *, aChan *, int, char **);
extern int del_user(aNick *, aChan *, int, char **);
extern int op(aNick *, aChan *, int, char **);
extern int deop(aNick *, aChan *, int, char **);
extern int admin_user(aNick *, aChan *, int, char **);
extern int kick(aNick *, aChan *, int, char **);
extern int kickban(aNick *, aChan *, int, char **);
extern int verify(aNick *, aChan *, int, char **);
extern int chaninfo(aNick *, aChan *, int, char **);
extern int admin_chan(aNick *, aChan *, int, char **);
extern int opall(aNick *, aChan *, int, char **);
extern int deopall(aNick *, aChan *, int, char **);
extern int mode(aNick *, aChan *, int, char **);
extern int topic(aNick *, aChan *, int, char **);
extern int rdeftopic(aNick *, aChan *, int, char **);
extern int rdefmodes(aNick *, aChan *, int, char **);
extern int ban_cmd(aNick *, aChan *, int, char **);
extern int info(aNick *, aChan *, int, char **);
extern int invite(aNick *, aChan *, int, char **);
extern int banlist(aNick *, aChan *, int, char **);
extern int clearmodes(aNick *, aChan *, int, char **);
extern int voice(aNick *, aChan *, int, char **);
extern int devoice(aNick *, aChan *, int, char **);
extern int clear_bans(aNick *, aChan *, int, char **);
extern int unban(aNick *, aChan *, int, char **);
extern int unbanme(aNick *, aChan *, int, char **);
extern int admin_do(aNick *, aChan *, int, char **);
extern int admin_say(aNick *, aChan *, int, char **);
extern int lastseen(aNick *, aChan *, int, char **);
extern int locktopic(aNick *, aChan *, int, char **);
extern int strictop(aNick *, aChan *, int, char **);
extern int nobans(aNick *, aChan *, int, char **);
extern int noops(aNick *, aChan *, int, char **);
extern int deftopic(aNick *, aChan *, int, char **);
extern int defmodes(aNick *, aChan *, int, char **);
extern int description(aNick *, aChan *, int, char **);
extern int csetwelcome(aNick *, aChan *, int, char **);
extern int myaccess(aNick *, aChan *, int, char **);
extern int banlevel(aNick *, aChan *, int, char **);
extern int voiceall(aNick *, aChan *, int, char **);
extern int devoiceall(aNick *, aChan *, int, char **);
extern int kickbanall(aNick *, aChan *, int, char **);
extern int kickall(aNick *, aChan *, int, char **);
extern int activwelcome(aNick *, aChan *, int, char **);
extern int see_alist(aNick *, aChan *, int, char **);
#ifdef USE_NICKSERV
extern int recover(aNick *, aChan *, int, char **);
#endif
extern int rehash_conf(aNick *, aChan *, int, char **);
extern int deauth(aNick *, aChan *, int, char **);
extern int restart_bot(aNick *, aChan *, int, char **);
extern int cs_wall(aNick *, aChan *, int, char **);
extern int show_ignores(aNick *, aChan *, int, char **);
extern int bantype(aNick *, aChan *, int, char **);
extern int chcomname(aNick *, aChan *, int, char **);
extern int chlevel(aNick *, aChan *, int, char **);
extern int oubli_pass(aNick *, aChan *, int, char **);
extern int disable_cmd(aNick *, aChan *, int, char **);
extern int ren_chan(aNick *, aChan *, int, char **);
extern int cmd_track(aNick *, aChan *, int, char **);
extern int chanurl(aNick *, aChan *, int, char **);
extern int write_files(aNick *, aChan *, int, char **);
extern int globals_cmds(aNick *, aChan *, int, char **);
extern int whoison(aNick *, aChan *, int, char **);
extern int set_protect(aNick *, aChan *, int, char **);
#ifdef HAVE_VOTE
extern int do_vote(aNick *, aChan *, int, char **);
extern int voter(aNick *, aChan *, int, char **);
extern int vote_results(aNick *, aChan *, int, char **);
#endif
extern int showconfig(aNick *, aChan *, int, char **);
extern int set_motds(aNick *, aChan *, int, char **);
extern int badmanage(aNick *, aChan *, int, char **);
extern int user_set(aNick *, aChan *, int, char **);

/*Welcome*/
extern int add_welcome(aNick *, aChan *, int, char **);
extern int del_welcome(aNick *, aChan *, int, char **);
extern int list_welcome(aNick *, aChan *, int, char **);

/*Moduser*/
extern int generic_moduser(aNick *, aChan *, int, char **);
extern int moduser_protect(aNick *, aChan *, int, char **);
extern int moduser_autovoice(aNick *, aChan *, int, char **);
extern int moduser_autoop(aNick *, aChan *, int, char **);

/*Chanopt*/
extern int generic_chanopt(aNick *, aChan *, int, char **);
extern int define_motd(aNick *, aChan *, int, char **);

int load_users(void);
int load_badchans(void);
int load_cmds(void);
int load_badnicks(void);
int load_chans(void);
void load_welcome(void);

void check_kills(void);
void check_bans(void);
void check_ignores(void);
void check_accounts(void);
void check_chans(void);

int resolve(const char *);

struct robot bot;
#ifdef USE_WELCOMESERV
struct bots ws;
#endif
struct bots cs;
/* Les needarg sonts les nombre d'arg minimum requis */

struct cs_commands cs_cmds[] = {
 /* cmd,            function,             niveau, needarg, flag, secure, 0*/
 /* Admins*/
 {  "die",          die,                  "", 4,      0, 2, 0, 0, "die" },
 {  "restart",      restart_bot,          "", 4,      0, 2, 0, 0, "restart" },
 {  "rehash",       rehash_conf,          "", 4,      0, 2, 0, 0, "rehash" },
 {  "adminlvl",     admin_level,          "", 4,      2, 2, 0, 0, "adminlvl" },
 {  "chcomname",    chcomname,            "", 4,      2, 2, 0, 0, "chcomname" },
 {  "chlevel",      chlevel,              "", 4,      2, 2, 0, 0, "chlevel" },
 {  "disable",      disable_cmd,          "", 4,      2, 2, 0, 0, "disable" },
#ifdef USE_WELCOMESERV
 {  "setglobwelcome",set_welcome,         "", 3,      0, 2, 0, 0, "setglobwelcome" },
#endif
 {  "inviteme",     inviteme,             "", 2,      0, 2, 0, 0, "inviteme" },
 {  "say",          admin_say,            "", 2,      2, 3, 0, 0, "say" },
 {  "write",        write_files,          "", 2,      0, 2, 0, 0, "write" },
 {  "cswall",       cs_wall,              "", 2,      1, 2, 0, 0, "cswall" },
 {  "global",       globals_cmds,         "", 2,      2, 2, 0, 0, "global" },
 {  "chan",         admin_chan,           "", 2,      1, 2, 0, 0, "chan" },
 {  "help",         aide,                 "", 0,      0, 0, 0, 0, "help" },
#ifdef HAVE_TRACK
 {  "track",         cmd_track,           "", 3,      1, 2, 0, 0, "track" },
#endif
 {  "user",         admin_user,           "", 2,      2, 2, 0, 0, "user" },
 {  "whoison",      whoison,              "", 2,      0, 3, 0, 0, "whoison" },
#ifdef HAVE_VOTE
 {  "vote",         do_vote,              "", 3,      0, 2, 0, 0, "vote" },
#endif
 /* Users (check with chan access)*/
 {  "unreg",        unreg_chan,           "", OWNERLEVEL, 1, 1, 0, 0, "unreg" },
 {  "renchan",      ren_chan,             "", OWNERLEVEL, 2, 1, 0, 0, "renchan" },
 {  "adduser",      add_user,             "", 450,    3, 1, 0, 0, "adduser" },
 {  "deluser",      del_user,             "", 450,    2, 1, 0, 0, "deluser" },
 {  "kickbanall",   kickbanall,           "", 450,    0, 1, 0, 0, "kickbanall" },
 {  "kickall",      kickall,              "", 400,    0, 1, 0, 0, "kickall" },
 {  "opall",        opall,                "", 400,    1, 1, 0, 0, "opall" },
 {  "deopall",      deopall,              "", 400,    1, 1, 0, 0, "deopall" },
 {  "clearmodes",   clearmodes,           "", 400,    0, 1, 0, 0, "clearmodes" },
 {  "voiceall",     voiceall,             "", 300,    1, 1, 0, 0, "voiceall" },
 {  "devoiceall",   devoiceall,           "", 300,    1, 1, 0, 0, "devoiceall" },
 {  "ban",          ban_cmd,              "", 100,    2, 1, 0, 0, "ban" },
 {  "unban",        unban,                "", 300,    2, 1, 0, 0, "unban" },
 {  "kickban",      kickban,              "", 300,    2, 1, 0, 0, "kickban" },
 {  "rdefmodes",    rdefmodes,            "", 300,    1, 1, 0, 0, "rdefmodes" },
 {  "rdeftopic",    rdeftopic,            "", 300,    1, 1, 0, 0, "rdeftopic" },
 {  "clearbans",    clear_bans,           "", 300,    0, 1, 0, 0, "clearbans" },
 {  "info",         info,                 "", 100,    0, 1, 0, 0, "info" },
 {  "invite",       invite,               "", 100,    0, 1, 0, 0, "invite" },
 {  "op",           op,                   "", 100,    1, 1, 0, 0, "op" },
 {  "deop",         deop,                 "", 100,    1, 1, 0, 0, "deop" },
 {  "kick",         kick,                 "", 100,    2, 1, 0, 0, "kick" },
 {  "mode",         mode,                 "", 100,    2, 1, 0, 0, "mode" },
 {  "topic",        topic,                "", 100,    2, 1, 0, 0, "topic" },
 {  "do",           admin_do,             "", 100,    2, 1, 0, 0, "do" },
 {  "devoice",      devoice,              "", 50,     1, 1, 0, 0, "devoice" },
 {  "voice",        voice,                "", 50,     1, 1, 0, 0, "voice" },
 {  "alist",        see_alist,            "", 1,      1, 1, 0, 0, "alist" },
 {  "unbanme",      unbanme,              "", 1,      1, 1, 0, 0, "unbanme" },
 /* Users (check with nick access)*/
 {  "listbadchans", list_badchans,        "", 1,      0, 0, 0, 0, "listbadchans" },
 {  "myaccess",     myaccess,             "", 1,      0, 0, 0, 0, "myaccess" },
 {  "drop",         drop_user,            "", 1,      1, 0, 2, 0, "drop" },
 {  "listbadnicks", list_badnicks,        "", 1,      0, 0, 0, 0, "listbadnicks" },
#ifdef HAVE_VOTE
 {  "voter",        voter,                "", 1,      0, 0, 2, 0, "voter" },
 {  "results",      vote_results,         "", 1,      0, 0, 0, 0, "results" },
#endif
#ifdef USE_MEMOSERV
 {  "memos",        memos,                "", 1,      2, 0, 1, 0, "memos" },
#endif
 {  "verify",       verify,               "", 1,      1, 0, 0, 0, "verify" },
 {  "register",     register_user,        "", 0,      2, 0, 1, 0, "register" },
 {  "login",        ns_login,             "", 0,      2, 0, 1, 0, "login" },
#ifdef USE_NICKSERV
 {  "recover",      recover,              "", 0,      0, 0, 1, 0, "recover" },
#endif
 {  "deauth",       deauth,               "", 0,      0, 4, 0, 0, "deauth" },
 {  "seen",         lastseen,             "", 0,      1, 0, 0, 0, "seen" },
 {  "regchan",      register_chan,        "", 0,      2, 0, 0, 0, "regchan" },
 {  "access",       show_access,          "", 0,      2, 1, 0, 0, "access" },
 {  "aide",         aide,                 "", 0,      0, 0, 0, 0, "aide" },
 {  "showcommands", showcommands,         "", 0,      0, 0, 0, 0, "showcommands" },
 {  "uptime",       uptime,               "", 0,      0, 0, 0, 0, "uptime" },
 {  "banlist",      banlist,              "", 0,      1, 1, 0, 0, "banlist" },
 {  "admin",        show_admins,          "", 0,      0, 0, 0, 0, "admin" },
 {  "whois",        cs_whois,             "", 0,      1, 0, 0, 0, "whois" },
 {  "ignorelist",   show_ignores,         "", 0,      0, 0, 0, 0, "ignorelist" },
 {  "oubli",        oubli_pass,           "", 0,      2, 0, 0, 0, "oubli" },
 {  "\001ping",     ctcp_ping,            "", 0,      0, 0, 0, 0, "\1ping" },
 {  "\001version\001", ctcp_version,      "", 0,      0, 0, 0, 0, "\1version\1" },
 {  "chaninfo",     chaninfo,             "", 0,      1, 1, 0, 0, "chaninfo" },
 /*moduser*/
 {  "moduser",      generic_moduser,      "", 450,    3, 1, 0, 0, "moduser" },
 {  "autoop",       moduser_autoop,       "", 450,    1, 1, 0, 0, "autoop" },
 {  "autovoice",    moduser_autovoice,    "", 450,     1, 1, 0, 0, "autovoice" },
 {  "protect",      moduser_protect,      "", 450,    1, 1, 0, 0, "protect" },
 /*chanopt*/
 {  "locktopic",    locktopic,            "", 400,    0, 1, 0, 0, "locktopic" },
 {  "strictop",     strictop,             "", 450,    0, 1, 0, 0, "strictop" },
 {  "nobans",       nobans,               "", 450,    0, 1, 0, 0, "nobans" },
 {  "noops",        noops,                "", 450,    0, 1, 0, 0, "noops" },
 {  "deftopic",     deftopic,             "", 400,    1, 1, 0, 0, "deftopic" },
 {  "defmodes",     defmodes,             "", 400,    1, 1, 0, 0, "defmodes" },
 {  "description",  description,          "", 450,    1, 1, 0, 0, "description" },
 {  "welcome",      csetwelcome,          "", 450,    1, 1, 0, 0, "welcome" },
 {  "setwelcome",   activwelcome,         "", 450,    1, 1, 0, 0, "setwelcome" },
 {  "banlevel",     banlevel,             "", 400,    1, 1, 0, 0, "banlevel" },
 {  "bantype",      bantype,              "", 400,    1, 1, 0, 0, "bantype" },
 {  "chanurl",      chanurl,              "", 450,    1, 1, 0, 0, "chanurl" },
 {  "motd",         define_motd,          "", 450,    1, 1, 0, 0, "motd" },
 {  "chanopt",      generic_chanopt,      "", 450,    2, 1, 0, 0, "chanopt" },
/* NOUVELLES COMMANDES ICI !*/
 {  "showconfig",   showconfig,           "", 4,      0, 2, 0, 0, "showconfig" },
#ifdef USE_WELCOMESERV
 {  "addwelcome",   add_welcome,          "", 4,      2, 2, 0, 0, "addwelcome" },
 {  "delwelcome",   del_welcome,          "", 4,      1, 2, 0, 0, "delwelcome" },
 {  "listwelcome",  list_welcome,         "", 4,      0, 2, 0, 0, "listwelcome" },
 {  "adminmotd",    set_motds,            "", 4,      2, 2, 0, 0, "adminmotd" },
#endif
 {  "abad",   badmanage,                  "", 3,      2, 2, 0, 0, "abad" },
 {  "set",   user_set,                    "", 1,      1, 0, 0, 0, "set" },
 {  "",             NULL,                 "", 0,      0, 0, 0, 0, "" }
};

void sig_handler(int);
void sig_reload(int);
void sig_alarm(int);
