/* src/main.h - Dclarations principales
 * Copyright (C) 2002-2003 Inter System
 *
 * contact: Progs@Inter-System.Net
 *          Cesar@Inter-System.Net
 *          kouak@kouak.org
 * site web: http://coderz.inter-system.net
 *
 * Services pour serveur IRC. Support sur IrcProgs et IrCoderZ
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include "../config.h"

#ifdef __GNUC__
#if (__GNUC__ < 2) || (__GNUC__ == 2 && __GNUC_MINOR__ < 7)
#define NO_ATTRIBUTE
#endif
#else
#define NO_ATTRIBUTE
#endif

#ifdef TESTBOT /* En effet, la version avec le web2cs c la version 2 :)*/
#define SPVERSION "1.2.0"
#else
#define SPVERSION "1.1.6"
#endif

#define CTCP_DELIM_CHAR '\001'
#define MAXPARA 16
#define MAXLEN 512

#define NICKLEN 30
#define TOPICLEN 250
#define HOSTLEN 63
#define REALEN 50
#define USERLEN 10
#define CHANLEN 200
#define REGCHANLEN 100
#define DESCRIPTIONLEN 80
#define NUHLEN NICKLEN + USERLEN + HOSTLEN + 3
#define MAILLEN 99
#define OWNERLEVEL 500 /* vous pouvez dfinir le niveau max dans un salon, mais, aprs ne le changer pas
						si vous avez une db active !! vous feriez ignorer tous les accs owner. */

/*si vous ne voulez pas tout logger, mettez rien entre les "" des diffrents fichiers*/
#define WAIT_DEL_PARSES 172800 /* Temps au bout duquel SCoderZ attend avant de del LOG_PARSES (172800 = 2 jours)*/
#define WAIT_DEL_LOGS 864000 /* Temps au bout duquel SCoderZ attend avant de del les autres fichiers de logs (864000 = 10 jours)*/
#define USERS_FILE "database/usr.db"
#define USRS_VERSION 19 /* version actuelle des fichiers ATTENTION: NE PAS CHANGER risque important de detruire la db*/
#define BADCHANS_FILE "database/badchans.db"
#define CHANS_FILE "database/chans.db"
#define WELCOME_FILE "database/welcome.db"
#define SETWELCOME_FILE "database/setwelcome.db"
#define BADNICKS_FILE "database/badnicks.db"
#define CMDS_FILE "database/cmds.db"
#define VOTE_FILE "database/votes.db"
#define REGISTER_TIMEOUT 86400 /* temps apres lequel un nick est purge si personne ne s'est auth lors de la procedure de register*/
#define PING_FREQ 90 /* interval des pings */
#define ALARMINTERVAL 25 /* interval de l'alarme (si Z rame beaucoup.. l'augmenter)*/
#define SCODERZ_PID "scoderz.pid" /* fichier o sera stock le n de pid de scoderz */

#define WAIT_CONNECT 10 /* Temps qu'attend le serveur avant de retenter une connexion */
#ifdef NO_ATTRIBUTE
#define CVSINFO(id) static char unused_CVSinfo[] = id
#else /* NO_ATTRIBUTE */
#define CVSINFO(id) static char CVSinfo[] __attribute__ ((unused)) = id
#endif /* NO_ATTRIBUTE */
#define IsAnAdmin(x) ((x) && (x)->level > 1) /* x est un admin ? */

#include <structs.h>
#include <proto.h>

#define AOp(x)		 ((x)->flag & A_OP)
#define AVoice(x)	 ((x)->flag & A_VOICE)
#define ASuspend(x)	 ((x)->flag & A_SUSPEND)
#define AProtect(x)	 ((x)->flag & A_PROTECT)
#define AWait(x) ((x)->flag & A_WAITACCESS)
#define SetAOp(x)	 ((x)->flag |= A_OP)
#define SetAVoice(x)	 ((x)->flag |= A_VOICE)
#define SetAProtect(x)	 ((x)->flag |= A_PROTECT)
#define SetASuspend(x)	 ((x)->flag |= A_SUSPEND)
#define DelAOp(x)	 ((x)->flag &= ~A_OP)
#define DelAVoice(x)	 ((x)->flag &= ~A_VOICE)
#define DelAProtect(x)	 ((x)->flag &= ~A_PROTECT)
#define DelASuspend(x)	 ((x)->flag &= ~A_SUSPEND)

#define NRegister(x)	 ((x)->flag & N_REGISTER)
#define SetNRegister(x)	 ((x)->flag |= N_REGISTER)
#define DelNRegister(x)	 ((x)->flag &= ~N_REGISTER)

#ifdef USE_NICKSERV
#define UPKill(x)	 ((x)->flag & U_PKILL)
#define UPNick(x)	 ((x)->flag & U_PNICK)
#define SetUPKill(x)	 ((x)->flag |= U_PKILL)
#define SetUPNick(x)	 ((x)->flag |= U_PNICK)
#define DelUPKill(x)	 ((x)->flag &= ~U_PKILL)
#define DelUPNick(x)	 ((x)->flag &= ~U_PNICK)
#define IsProtected(x)	 ((x)->flag & (U_PNICK | U_PKILL))
#endif /* USE_NICKSERV */
#define UWantDrop(x)	 ((x)->flag & U_WANTDROP)
#define UWantX(x)	 ((x)->flag & U_WANTX)
#define UNopurge(x)	 ((x)->flag & U_NOPURGE)
#define UOubli(x)	 ((x)->flag & U_OUBLI)
#define UFirst(x)	 ((x)->flag & U_FIRST)
#define UNoMemo(x)	 ((x)->flag & U_NOMEMO)
#define SetUWantX(x)	 ((x)->flag |= U_WANTX)
#define SetUWantDrop(x)	 ((x)->flag |= U_WANTDROP)
#define SetUNopurge(x)	 ((x)->flag |= U_NOPURGE)
#define SetUOubli(x)	 ((x)->flag |= U_OUBLI)
#define SetUFirst(x)	 ((x)->flag |= U_FIRST)
#define SetUNoMemo(x)	 ((x)->flag |= U_NOMEMO)
#define DelUWantX(x)	 ((x)->flag &= ~U_WANTX)
#define DelUWantDrop(x)	 ((x)->flag &= ~U_WANTDROP)
#define DelUNopurge(x)	 ((x)->flag &= ~U_NOPURGE)
#define DelUOubli(x)	 ((x)->flag &= ~U_OUBLI)
#define DelUFirst(x)	 ((x)->flag &= ~U_FIRST)
#define DelUNoMemo(x)	 ((x)->flag &= ~U_NOMEMO)

#define CSetWelcome(x)		((x)->flag & C_SETWELCOME)
#define CJoined(x)		((x)->flag & C_JOINED)
#define CStrictOp(x)		((x)->flag & C_STRICTOP)
#define CLockTopic(x)		((x)->flag & C_LOCKTOPIC)
#define CNoBans(x)		((x)->flag & C_NOBANS)
#define CWantUnreg(x)		((x)->flag & C_WANTUNREG)
#define CNoOps(x)		((x)->flag & C_NOOPS)
#define CAutoInvite(x)		((x)->flag & C_AUTOINVITE)
#define CFLimit(x)			((x)->flag & C_FLIMIT)
#define SetCSetWelcome(x)	((x)->flag |= C_SETWELCOME)
#define SetCJoined(x)		((x)->flag |= C_JOINED)
#define SetCStrictOp(x)		((x)->flag |= C_STRICTOP)
#define SetCLockTopic(x)	((x)->flag |= C_LOCKTOPIC)
#define SetCNoBans(x)		((x)->flag |= C_NOBANS)
#define SetCWantUnreg(x)	((x)->flag |= C_WANTUNREG)
#define SetCNoOps(x)		((x)->flag |= C_NOOPS)
#define DelCSetWelcome(x)	((x)->flag &= ~C_SETWELCOME)
#define DelCJoined(x)		((x)->flag &= ~C_JOINED)
#define DelCStrictOp(x)		((x)->flag &= ~C_STRICTOP)
#define DelCLockTopic(x)	((x)->flag &= ~C_LOCKTOPIC)
#define DelCNoBans(x)		((x)->flag &= ~C_NOBANS)
#define DelCWantUnreg(x)	((x)->flag &= ~C_WANTUNREG)
#define DelCNoOps(x)		((x)->flag &= ~C_NOOPS)

#define ChanCmd(x) (cs_cmds[(x)].flag & CMD_CHAN)
#define AdmCmd(x) (cs_cmds[(x)].flag & CMD_ADMIN)
#define IsSuspend(x) ((x)->suspend && (x)->suspend->expire >= 0 && (!(x)->suspend->expire || ((x)->suspend->debut + (x)->suspend->expire) > time(NULL)))
#define CantRegChan(x) ((x)->cantregchan >= 0 && (!(x)->cantregchan || (x)->cantregchan > time(NULL)))
#define NOSUCHUSER "\002%s\2 n'est pas un Username enregistr."
#define NOSUCHAN "\002%s\2 n'est pas un salon enregistr."
#define NOTCONNECTED "%s n'est pas connect."
#define PLUR(x) ((x) > 1 ? "s" : "")
#define NONE(x) ((x) ? (x) : "")

#define SPECIAL_CHAR "{}[]|-_\\^`"

#ifndef GLOBALS_DEF
extern struct robot bot;
#ifdef USE_WELCOMESERV
extern struct bots ws;
#endif
extern struct bots cs;
extern struct nickinfo *nickhead;
extern struct userinfo *userhead;
extern struct chaninfo *chanhead;
#endif

#define CF_XMODE 0x0001
#define CF_ADMINEXEMPT 0x0002
#define CF_KILLFORFLOOD 0x0004
#define CF_CHANGENICK 0x0008
#define CF_HOSTHIDING 0x0010
#define CF_WELCOME 0x0020
#define CF_PRIVWELCOME 0x0040
#define CF_HIDE_ADML4 0x0080
#define CF_NOREG 0x0100

#ifdef N2K
#define TOKEN_PRIVMSG "P"
#define TOKEN_PING "G"
#define TOKEN_NICK "N"
#define TOKEN_JOIN "J"
#define TOKEN_PART "L"
#define TOKEN_MODE "M"
#define TOKEN_KICK "K"
#define TOKEN_CREATE "C"
#define TOKEN_QUIT "Q"
#define TOKEN_ACCOUNT "AC"
#define TOKEN_BURST "B"
#define TOKEN_AWAY "A"
#define TOKEN_SERVER "S"
#define TOKEN_SQUIT "SQ"
#define TOKEN_TOPIC "T"
#define TOKEN_KILL "D"
#define TOKEN_WHOIS "W"
#define TOKEN_PASS "PASS"
#define TOKEN_EOB "EB"
#define TOKEN_EOBACK "EA"
#define TOKEN_PONG "Z"
#define TOKEN_WALLOPS "WA"
#define TOKEN_NOTICE "O"
#define TOKEN_SVSMODE "SVSMODE"
#define TOKEN_SVSNICK "SVSNICK"
#define TOKEN_INVITE "I"
#define TOKEN_GLINE "GL"
#define TOKEN_WALLCHOPS "WC"
#else
#define TOKEN_PRIVMSG "PRIVMSG"
#define TOKEN_PING "PING"
#define TOKEN_NICK "NICK"
#define TOKEN_JOIN "JOIN"
#define TOKEN_PART "PART"
#define TOKEN_MODE "MODE"
#define TOKEN_KICK "KICK"
#define TOKEN_CREATE "CREATE"
#define TOKEN_QUIT "QUIT"
#define TOKEN_ACCOUNT "ACCOUNT"
#define TOKEN_BURST "BURST"
#define TOKEN_AWAY "AWAY"
#define TOKEN_SERVER "SERVER"
#define TOKEN_SQUIT "SQUIT"
#define TOKEN_TOPIC "TOPIC"
#define TOKEN_KILL "KILL"
#define TOKEN_WHOIS "WHOIS"
#define TOKEN_SETHOST "SETHOST"
#define TOKEN_SETIDENT "SETIDENT"
#define TOKEN_PASS "PASS"
#define TOKEN_EOB "END_OF_BURST"
#define TOKEN_EOBACK " EOB_ACK"
#define TOKEN_PONG "PONG"
#define TOKEN_WALLOPS "WALLOPS"
#define TOKEN_NOTICE "NOTICE"
#define TOKEN_SVSMODE "SVSMODE"
#define TOKEN_SVSNICK "SVSNICK"
#define TOKEN_INVITE "INVITE"
#define TOKEN_GLINE "GLINE"
#define TOKEN_WALLCHOPS "WALLCHOPS"
#endif

#define DEFAUT_LIMITINC 3
#define DEFAUT_LIMITMIN 3
#define DEFAUT_BANLEVEL 300
#define DEFAUT_CMODELEVEL 300
