/* include/proto.h - Dclaration des diffrentes fonctions
 * Copyright (C) 2002-2003 Inter System
 *
 * contact: Progs@Inter-System.Net
 *          Cesar@Inter-System.Net
 *          kouak@kouak.org
 * site web: http://coderz.inter-system.net
 *
 * Services pour serveur IRC. Support sur IrcProgs et IrCoderZ
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* Outils serveur */
void putserv(const char *, ...);
void putchan(const char *);
void putlog(const char *, const char *, ...);
int csntc(aNick *, const char *, ...);
int syntax_cmd(aNick *, int);
void csmode(aChan *, const char *, ...);
void cstopic(aChan *, const char *);
void cskick(const char *, const char *, const char *, ...);
void cspart(aChan *, const char *);
void cswallops(const char *, ...);
void cswall(const char *, ...);
void csjoin(aChan *);
void cs_account(aNick *, const char *);
void mylog(const char *filename, const char *format, ...);

char *GetModes(aNick *);
char *GetCModes(aChan *);
char *make_servnum(int);
char *get_time(time_t ttime);
char *GetPrefix(aNick *);
char *GetChanPrefix(aNick *, aJoin *, int);
char *GetUserOptions(anUser *);
char *GetAccessOptions(anAccess *);
char *parv2msg(unsigned int, char **, unsigned int, unsigned int);
void parv2msgn(unsigned int parc, char **, unsigned int, char *, unsigned int);
char *mkpass(const char *);
char *duration(int);
char *GetBanType(aChan *);
void conv_char(char *, char *);
aNick *num2nickinfo(const char *);
struct Link *num2servinfo(const char *);
anUser *ParseNickOrUser(aNick *, char *);
void do_chan_suspend(aChan *, const char *, const char *, time_t, time_t);
void show_suspend(aNick *, aChan *);
void do_user_suspend(anUser *, const char *, const char *, time_t, time_t);
void show_ususpend(aNick *, anUser *);

int is_ip(const char *);
time_t convert_duration(const char *);
void strupr(char *);
void strip_newline(char *);
void strlwr(char *buf);
int is_num(const char *num);
int match(const char *, const char *);
int ToggleFlag(int *, int);
char *str_dup(char **, const char *);
char *Strncpy(char *, const char *, size_t);

#ifdef HAVE_TRACK
struct track *istrack(anUser *);
void del_track(anUser *);
#endif
void show_vote(aNick *);

/* Fichiers*/
void write_anuser(anUser *);
void write_userlist(void);
void write_users(void);
void write_badchans(void);
void write_achan(aChan *);
void write_chans(void);
void write_chanlist(void);
void write_welcome(void);
void write_badnicks(void);
void write_cmds(void);
void write_bans(aChan *);
void load_votes(void);
void write_votes(void);
void append_file(const char *, const char *);
void File_UserDel(char *);
int load_config(const char *);

/* Get Infos*/
int IsBadNick(const char *);
char *IsAnOwner(anUser *);

char *getbanmask(aNick *, int);
char *pretty_mask(char *);
void show_accessn(anAccess *, anUser *, aNick *);
int ChanLevelbyUserI(anUser *, const char *);
int check_protect(aNick *, aNick *, const char *);
int checkflood(aNick *);
int chan_check(const char *, aNick *);
int getoption(const char *, char **, int, int, int);
int IsValidNick(char *);
int IsValidMail(char *);
int GetCmdIndexbyName(const char *);
int GetCurCmdIndexbyName(const char *);
char *RealCmd(const char *);
int checkpass(const char *, anUser *);
aBan *is_ban(aNick *, aChan *);
int GetConf(const unsigned int);

anUser *getuserinfo(const char *);
struct badchans *getbadchan(const char *);
aChan *getchaninfo(const char *);
struct badnicks *getbadnick(const char *);
aJoin *getjoininfo(aNick *, const char *);
aNick *getnickbynick(const char *);
anAccess *GetAccessIbyUserI(anUser *, const char *chan);
struct Link *GetLinkIbyServ(const char *serv);
aNick *GetMemberIbyNum(aChan *, const char *);
aNick *GetMemberIbyNick(aChan *, const char *);

/* Add/Del infos*/
#ifdef USE_MEMOSERV
void add_memo(anUser *user, const char *, time_t, const char *, int);
void del_memo(anUser *user, unsigned int);
#endif
anUser *add_regnick(const char *, const char *, time_t, int, int, const char *, int);
void del_regnick(anUser *user);
void del_nickinfo(aNick *);
aNick *add_nickinfo(const char *, const char *, const char *, const char *, const char *, struct Link *, const char *, time_t);
struct badchans *add_abadchan(const char *, const char *);
void del_abadchan(const char *);
aChan *add_chan(const char *, const char *, const char *, const char *, const char *, const char *, const char *, const char *);
anAccess *add_access(anUser *, const char *, int, int, time_t);
void del_chan(aChan *, const char *);
void del_access(anUser *, aChan *);
void add_killinfo(aNick *, time_t, int, int);
void del_killinfo(aNick *, const char *);
void add_abadnick(const char *, int flag);
void del_abadnick(const char *);
void add_join(aNick *, char *, int, int, time_t, int, aChan *);
void del_join(aNick *, const char *);
void del_link(aChan *, aNick *);
void add_ban(aChan *, const char *, const char *, const char *, time_t, time_t, int);
void del_ban(aChan *, aBan *);
void add_ignore(const char *, time_t);
void del_ignore(const char *);
void parse_umode(aNick *, char *);
void parse_cmode(aChan *, char *, const char *, const char *);

void show_notes(aNick *);

#ifdef SQLLOG
int sql_query(const char *, ...);
int sql_init(void);
#endif
