/* include/structs.h - Dclaration des diffrentes structures
 * Copyright (C) 2002-2003 Inter System
 *
 * contact: Progs@Inter-System.Net
 *          Cesar@Inter-System.Net
 *          kouak@kouak.org
 * site web: http://coderz.inter-system.net
 *
 * Services pour serveur IRC. Support sur IrcProgs et IrCoderZ
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/*------------------- Structures robot -------------------*/
struct robot {
  char server[150];
#ifdef N2K
  char servnum[3];
#else
  char servnum[2];
#endif
  int num;
  char pass[21];
  int port;
  char name[REALEN + 1];
  char ip[16];
  char chan[REGCHANLEN + 1];
  char pchan[REGCHANLEN + 1];
  char cara;
  int sock;
  int ipnum;
  time_t uptime;
  time_t lasttime; /* pour traffic */
  long lastbytes;

#ifdef SQLLOG
  MYSQL *sql_id;
  char sql_db[30];
  char sql_ip[16];
  char sql_user[30];
  char sql_pass[30];
  int sql_port;
#endif
};

struct bots {
  char nick[NICKLEN + 1];
  char ident[USERLEN + 1];
  char host[HOSTLEN + 1];
  char name[REALEN + 1];
  char mode[10];
#ifdef N2K
  char num[6];
#else
  char num[4];
#endif
};

struct suspendinfo {
	char from[NICKLEN + 1];
	char raison[251];
	time_t expire;
	time_t debut;
};

/*------------------- Structures informations serveurs -------------------*/

struct Link {
	char serv[150];
#ifdef N2K
	char num[3];
#else
	char num[2];
#endif
	int flag;
#define ST_BURST 0x01
#define ST_ONLINE 0x02
#define ISHUB 0x04
	struct Link *next;
	struct Link *last;
	struct Link *hub;
};

/*------------------- Structures users et accs -------------------*/
typedef struct nickinfo {
	char nick[NICKLEN + 1];
	char ident[USERLEN + 1];
	char host[HOSTLEN + 1];
#ifdef HAVE_CRYPTHOST
	char crypt[HOSTLEN + 1];
#endif
	struct Link *serveur;
	char name[REALEN + 1];
	char base64[7];
#ifdef N2K
	char numeric[6];
#else
	char numeric[4];
#endif
	int flag;
#define N_REGISTER		 0x0001
#define N_AWAY 			0x0002
#define N_OPER 			0x0004
#define N_SERVICE 0x0008
#define N_ADM 0x0010
#define N_INV 0x0020
#define N_GOD 0x0040
#define N_WALLOPS 0x0080
#define N_DEBUG 0x0100
#define N_FEMME 0x0200
#define N_HOMME 0x0400
#define N_CRYPT 0x0800
#define N_REG 0x01000
#define N_DIE 0x02000
#define N_DEAF 0x04000
#define N_SPOOF 0x08000
	time_t ttmco;
	time_t floodtime;
	int floodcount;
	struct userinfo *user;
	struct nickinfo *next;
	struct nickinfo *last;
	struct joininfo *joinhead;
} aNick;

typedef struct userinfo {
   char nick[NICKLEN + 1];
   char passwd[20];
   int level;
   time_t lastseend;
   int flag;
#ifdef USE_NICKSERV
#define U_PKILL		 0x0001
#define U_PNICK		 0x0002
#endif
#define U_WANTDROP	 0x0004
#define U_NOPURGE	 0x0008
#define U_WANTX		 0x0010
#define U_OUBLI		 0x0020
#define U_FIRST 	 0x0040
#define U_NOMEMO	 0x0080
#define U_PREJECT	 0x0100
#define U_POKACCESS	 0x0200
#define U_PACCEPT	 0x0400
#define U_ALREADYCHANGE	 0x0800
   char mail[MAILLEN + 1];
   char *lastlogin;
   time_t cantregchan;
#ifdef HAVE_VOTE
   int vote;
#endif
   struct suspendinfo *suspend;
   struct access *accesshead;
   aNick *n;
#ifdef USE_MEMOSERV
   struct memos *memohead;
#endif
   struct userinfo *next;
   struct userinfo *last;
} anUser;

typedef struct access {
   char chan[REGCHANLEN + 1];
   int level;
   int flag;
#define A_OP		 0x01
#define A_VOICE		 0x02
#define A_PROTECT	 0x04
#define A_SUSPEND	 0x08
#define A_WAITACCESS 0x10
   time_t lastseen;
   char *info;
   struct chaninfo *c; /* pour rediriger vers la struct du chan o on a access.*/
   struct userinfo *user;
   struct access *next;
} anAccess;

#ifdef USE_MEMOSERV
typedef struct memos {
   char de[NICKLEN + 1];
   int date;
   char message[MEMOLEN + 1];
   int read; /* actif une fois que le memo a t lu */
   struct memos *next;
} aMemo;
#endif

struct badnicks {
	char chaine[NICKLEN + 1];
	int flag;
	struct badnicks *next;
};

struct Modes {
	char mode;
	int value;
};

/*------------------- Structures chans -------------------*/
struct badchans {
	char chaine[100];
	char raison[150];
	struct badchans *next;
};

typedef struct chaninfo {
	char chan[REGCHANLEN + 1];/* infos sur le salon actuel du rseau*/
	char topic[TOPICLEN + 1];
	time_t chanstamp;
	char key[24];
	int limit;
	int users;
	int mode;
#define C_MMSG 		0x001
#define C_MTOPIC 	0x002
#define C_MINV 		0x004
#define C_MLIMIT 	0x008
#define C_MKEY 		0x010
#define C_MSECRET 	0x020
#define C_MPRIVATE 	0x040
#define C_MMODERATE 0x080
#define C_MNOCTRL 	0x100
#define C_MNOCTCP 	0x200
#define C_MOPERONLY 0x400
#define C_MUSERONLY 0x800

	char defmodes[30];/* proprits du salon reg*/
	char deftopic[TOPICLEN + 1];
	char welcome[TOPICLEN + 1];
	char description[DESCRIPTIONLEN + 1];
	char *motd;
	char url[101];
	int flag;
#define C_SETWELCOME	0x0001
#define C_JOINED		0x0002
#define C_STRICTOP		0x0004
#define C_LOCKTOPIC		0x0008
#define C_NOBANS		0x0010
#define C_WANTUNREG		0x0020
#define C_NOOPS			0x0040
#define C_AUTOINVITE 	0x0080
#define C_ALREADYRENAME 0x0100
#define C_FLIMIT 		0x0200
	int banlevel;
	int cml;
	int bantype;
	int limit_inc;
	int limit_min;
	time_t bantime;
	struct baninfo *banhead;
	struct suspendinfo *suspend;
	struct SLink *access; /* utiliser un link pour avoir la liste des access plus rapidement*/
	struct SLink *members; /* listes ds users dans le chan*/
	struct chaninfo *next;
} aChan;

typedef struct baninfo {
	char mask[100];
	char *raison;
	char de[NICKLEN + 1];
	time_t debut;
	time_t fin;
	int level;
	struct baninfo *next;
	struct baninfo *last;
} aBan;

struct welcomeinfo {
	int id;
	char msg[250];
	int level;
	struct welcomeinfo *next;
};

typedef struct joininfo
{
   char channel[CHANLEN + 1];
   int is_op;
   int is_voice;
   time_t timestmp;
   aNick *nick;
   struct chaninfo *chan;
   struct joininfo *next;
} aJoin;

/*------------------- Structures flood et kill -------------------*/
typedef struct killinfo
{
	aNick *nick;
	char against[NICKLEN + 1];
	time_t timestamp;
	int why;
	int setkill;
	struct killinfo *next;
} aKill;

struct ignore
{
	char host[HOSTLEN + 1];
	time_t exp;
	struct ignore *next;
};

#ifdef HAVE_VOTE
struct votes
{
	char prop[200];
	int voies;
};
#endif

#ifdef HAVE_TRACK
struct track
{
	aNick *tracker;
	anUser *tracked;
	time_t from;
	time_t expire;
	struct track *next;
};
#endif

/*------------------- Structures conf, parses et cmds -------------------*/
struct aConfPara {
  char *name;
  int flag;
  char *syntax;
};

struct aMsg {
  const char *cmd;
  void (*func) (int parc, char **parv);
};

struct cs_commands {
   char cmd[15];
   int (*func) (aNick *nick, aChan *chaninfo, int parc, char **parv);
   char syntax[250];
   int level;
   int args;
   int flag;
   int secure;
#define CMD_CHAN 0x1
#define CMD_ADMIN 0x2
#define CMD_DISABLE 0x4
   int used;
   char realcmd[15];
};

/*------------------- Structures pour les Links -------------------*/

typedef struct SLink {
  struct SLink *next;
  union {
    anAccess *a;
    aJoin *j;
  } value;
} aLink;
