<?php

define("NICKLEN", 30);
define("SERVEUR", "192.168.0.10");
define("PORT", 6969);
define("PASSWD", "521cOFE54gDEk");
define("ERR", "^10[0-9]{1}");

/*
 * Etablit la connexion au web2cs
 * Renvoie -1 en cas d'chec
 * 0 si la connexion est dja active
 * 1 pour une connexion sans chec
 *
 */
function w2c_getconnection($nick, $pass)
{
	$fp = fsockopen(SERVEUR, PORT, $errno, $errstr, 30);

	if ($fp == NULL)
	{
		echo "$errstr ($errno)";
		return -2;
	}
	else {
		fputs($fp, "PASS ".PASSWD."\n");
		$get = trim(fgets($fp,1024));
		$numeric = strtok($get, ' ');
		if($numeric != 100) return -2;
		fputs($fp, "LOGIN ".$nick." ".$pass."\n");
		$stop = "^21";
		while (!ereg($stop, $get))
		{
			$get = trim(fgets($fp,1024));
		}
		$numeric = strtok($get, ' ');
		if($numeric == 210) return -1;
		elseif($numeric == 211) return $fp;
		elseif($numeric == 212) return 0;
	}
	return -1;
}

function w2c_getmyaccess($fp)
{
	$tableau = array();
	$i = 0;
	if(!$fp) return $tableau;
	fputs($fp, "MYACCESS\n");
	$debut = "(^240)(.*)";
	$opt = "(^241) ([^ ]*) (.*)$";
	$access = "(^242)(.*)";
	$waccess = "(^243)(.*)";

	do {
		$get = trim(fgets($fp,1024));
		if(ereg($debut, $get, $regs)) { $tableau[0] = $regs[2]; }
		elseif(ereg($opt, $get, $regs)) { $tableau[1][$i] = array(); $tableau[1][$i][0] = $regs[2]; $tableau[1][$i][1] = $regs[3]; $i++; }
		elseif(ereg($access, $get, $regs)) $tableau[2] = $regs[2];
		elseif(ereg($waccess, $get, $regs)) $tableau[3] = $regs[2];
	} while (!w2c_checkerr($get));
	return $tableau;
}

function w2c_getchaninfo($fp, $chan)
{
	$tableau = array();
	$i = 0;
	if(!$fp || !$chan) return $tableau;


	fputs($fp, "CHANINFO ".$chan."\n");
	$chaninfo = "(^221) ([^ ]*) (.*)$";
	$nonreg = "^106";

	do {
		$get = trim(fgets($fp,1024));
		if(ereg($nonreg, $get)) return -1;
		if(ereg($chaninfo, $get, $regs)) {
			$tableau[$i][0] = $regs[2];
			$tableau[$i][1] = $regs[3];
			$i++;
		}
	} while (!w2c_checkerr($get));

	return $tableau;
}

function w2c_getaccess($fp, $chan, $nick, $aop, $avoice, $suspend, $protect)
{
	$tableau = array();
	$i = 0;
	if(!$chan || !$fp) return $tableau;

	$query 	= "ACCESS ".$chan
			. ($nick ? " ".$nick : "*")
			. ($aop ? " -autoop" : "")
			. ($avoice ? " -autovoice" : "")
			. ($suspend ? " -suspend" : "")
			. ($protect ? " -protect" : "")
			. "\n";

	$nosuchchannel = "^106";
	$debut = "(^230)(.*)";
	$opt = "(^231)(.*)";
	$seen = "(^232)(.*)";
	$info = "(^233)(.*)";
	$stop = "^234";
	$fullstop = "^235";

	fputs($fp, $query);

	do {
		$get = trim(fgets($fp,1024));
		if(ereg($nosuchchannel, $get)) return -1;
		if(ereg($debut, $get, $regs)) $tableau[$i][0] = $regs[2];
		elseif(ereg($opt, $get, $regs)) $tableau[$i][1] = $regs[2];
		elseif(ereg($seen, $get, $regs)) $tableau[$i][2] = $regs[2];
		elseif(ereg($info, $get, $regs)) $tableau[$i][3] = $regs[2];
		elseif(ereg($stop, $get)) $i++;
		elseif(ereg($fullstop, $get)) break;
	} while (!w2c_checkerr($get));

	return $tableau;
}

function w2c_isaccesslevel($string)
{
	if(ereg("^(<|>|=){1}[0-5]?[0-9]{1,2}$", $string)) return 1;
	else return 0;
}

function w2c_isvalidchan($string)
{
	if($string[0] != "#") return 0;
	if(strlen($string) > 30) return 0;
// Not yet implemented
//	$stop = "^#[A-Z0-9\ #]";
//	if(ereg($stop, $string)) return 0;
	return 1;

}

function w2c_stripircchars($string)
{
  $regex = "\002|\037|\22|\003[0-9]{0,2}(,[0-9]{0,2})?";
  $string = ereg_replace($regex, "", rtrim($string));
  return $string;
}

function w2c_isvalidemail($email)
{
	return ereg("^[_a-zA-Z0-9-]+(\.[_a-zA-Z0-9-]+)*@[a-zA-Z0-9-]+(\.[a-zA-Z0-9-]+)*\.(([0-9]{1,3})|([a-zA-Z]{2,3})|(aero|coop|info|museum|name))$", $email);
}

function w2c_isvalidusername($username)
{
	return ereg("^([a-zA-Z]|_|`|\\{|\\[|]|}|\\||\\\\|\\^){1}([a-zA-Z0-9]|_|`|\\{|\\[|]|}|\\||\\\\|-|\\^){1,".(NICKLEN - 1)."}$",$username);
}

function w2c_isvalidpass($mdp)
{
	return ereg("^[^[:space:]]{6,15}$", $mdp);
}

function w2c_register($pseudo, $email, $pass)
{
	if(!$pseudo || !$email) return 0; /* Should never happen ... */
	if(!w2c_isvalidemail($email)) return -2;
	if(!w2c_isvalidusername($pseudo)) return -3;
	if(!$pass || !w2c_isvalidpass($pass)) $pass = w2c_generatepass();

	$fp = fsockopen(SERVEUR, PORT, $errno, $errstr, 30);

	if (!$fp)
	{
		echo "$errstr ($errno)";
		return -1;
	}

	fputs($fp, "REGISTER ".$pseudo." ".$email." ".$pass."\n");

	$stop = "^101";
	$erruser = "^250";
	$errmail = "^251";

	do {
		$get = trim(fgets($fp,1024));
		if(ereg($stop,$get)) { fclose($fp); return -1; } /* Erreur ... Donnes invalides */
		elseif(ereg($erruser,$get)) { fclose($fp); return -4; }  /* Pseudo dja enregistr / Invalide */
		elseif(ereg($errmail, $get)) { fclose($fp); return -5; }  /* Email dja utilis */
	} while (!w2c_checkerr($get));

	fclose($fp);
	echo "Votre compte a t enregistr :<br />"
		."Login : ".$pseudo."<br />"
		."Pass : ".$pass."<br />";

	return 1;

}

function w2c_send_memo($fp, $rcpt, $text)
{
	if(!($fp && $rcpt && $text)) return -1;

	$query = "MEMOS SEND ".$rcpt." ".$text."\n";
	$nosuchnick = "^105";
	$nomemo = "^293";
	$stop = "^100";

	fputs($fp, $query);

	do {
		$get = trim(fgets($fp,1024));
		if(ereg($nosuchnick, $get)) return -3;
		elseif(ereg($nomemo, $get)) return -4;
		elseif(ereg($stop, $get)) return 1;
	} while (!w2c_checkerr($get));
}

function w2c_read_memo($fp, $q)
{
	$i = 0;
	$tableau = array();

	if(!$fp) return -1;
	if(!$q) $q = "ALL";

	$end = "(^291) (.*)$";
	$nomemo = "^292";
	$memo = "(^290) (0|1) ([^ ]+) ([0-9]+) (.*)";

	fputs($fp, "MEMOS LIRE ".$q."\n");

	do {
		$get = trim(fgets($fp,1024));
		if(ereg($memo, $get, $regs)) { $tableau[$i][0] = $regs[3]; $tableau[$i][1] = $regs[4]; $tableau[$i][2] = $regs[5]; $tableau[$i][3] = $regs[2]; $i++; }
		elseif(ereg($nomemo, $get)) return -4;
		elseif(ereg($end, $get)) { $tableau[$i] = $regs[2]; return $tableau; }
	} while (!w2c_checkerr($get));

}

function w2c_suppr_memo($fp, $q)
{
	$i = 0;
	$tableau = array();

	if(!$fp) return -1;
	if(!$q) $q = "ALL";

	$end = "(^291) (.*)$";
	$nomemo = "^292";

	fputs($fp, "MEMOS SUPPR ".$q."\n");

	do {
		$get = trim(fgets($fp,1024));
		if(ereg($nomemo, $get)) return 0;
		elseif(ereg($end, $get)) { return $regs[2]; }
	} while (!w2c_checkerr($get));
}

function w2c_moduser($chan, $user, $what)
{
/* Pas termine */
	return;
}

function w2c_generatepass()
{
		for($j=0;$j<=10;$j++)
		{
			do $i = rand(1,9999) %57 + 65;
			while($i >= 91 && $i <= 96);
			$c .= chr($i);
		}
		return $c;
}

function w2c_char2html($string)
{
	return ircg_html_encode($string);
}

function w2c_checkerr($get)
{
	return ereg(ERR, $get);
}
?>
