/* src/admin_user.c - commandes admins pour gerer les users
 * Copyright (C) 2002-2003 Inter System
 *
 * contact: Progs@Inter-System.Net
 *          Cesar@Inter-System.Net
 *          kouak@kouak.org
 * site web: http://coderz.inter-system.net
 *
 * Services pour serveur IRC. Support sur IrcProgs et IrCoderZ
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "admin_user.h"

static int b2n (int b)
{
	int i = 0;
	const char bbbase64[64] = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789[]";

	for (; i<64; i++) if (bbbase64[i] == b) return i;

	return i;
}

static char *GetIP(char *base64)
{
	int i = 5, poids = 1, addr = 0;
	struct in_addr addr2;
	static char Ip[16];

	for(;i >= 0;poids *= 64) addr += poids * b2n(base64[i--]);

	addr2.s_addr = htonl(addr);
	strncpy(Ip, inet_ntoa(addr2), 16);
	return Ip;
}

int cs_whois(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	char *user = parv[1], chans[451] = {0}, b[CHANLEN + 3] = {0}, *p;
	int auth = (nick->nick == user || IsAnAdmin(nick->user)), size = 0, first = 0;
	aNick *tmp;
	aJoin *chanl;
	anAccess *acces;
	anUser *ux;

	if(!(tmp = getnickbynick(user))) return csntc(nick, NOTCONNECTED, user);

	csntc(nick, "Infos sur \2%s", tmp->nick);
	csntc(nick, " Nom: %s", tmp->name);
#ifdef HAVE_CRYPTHOST
	csntc(nick, " Mask: %s\2%s\2!\002%s\2@\002%s", GetPrefix(tmp), tmp->nick, tmp->ident, tmp->crypt);
	if(auth) csntc(nick, " Realhost: \002%s\2", tmp->host);
#else
	csntc(nick, " Mask: %s\2%s\2!\002%s\2@\002%s", GetPrefix(tmp), tmp->nick, tmp->ident, IsAnAdmin(nick->user) ? tmp->host : "*");
#endif
	if(auth) csntc(nick, " IP: \002%s", GetIP(tmp->base64));
	if((tmp->flag & N_OPER)) csntc(nick, " %s est \2IRCop.", tmp->nick);
	p = GetModes(tmp);
	if(auth) csntc(nick, " UserModes: \2%s\2", *p ? p : "Aucun");
	if(auth)
	{
		for(chanl = tmp->joinhead;chanl;chanl=chanl->next)
		{
			int tmps = size, p = snprintf(b, CHANLEN + 3, "%s%s%s ", chanl->is_voice ? "+" : "", chanl->is_op ? "@" : "", chanl->channel);
			size += p > 0 ? p : (CHANLEN + 3);
			if(size >= 450) /* le dernier fait depasser le buffer */
			{
				csntc(nick, "%s%s ...", !first ? " Il est sur: " : "", chans);
				strcpy(chans, b); /* ajoute le suivant pour la prochaine*/
				first = 1;
				size = strlen(b);
			}
			else strcpy(&chans[tmps], b);
		}
		if(chans[0] == '\0') strcpy(chans, "Aucun salon");

		csntc(nick, "%s%s", !first ? " Il est sur: " : "", chans);
	}
	if(tmp->user)
	{
		csntc(nick, " %s est logu sous l'username \2%s\2%s", user, tmp->user->nick,
			IsAnAdmin(tmp->user) ? " (\2Admin\2)" : "");
		if(auth)
		{
			chans[0] = '\0';
			size = first = 0;

			for(acces = tmp->user->accesshead;acces;acces=acces->next)
			{
				int tmps = size, p;
				if(AWait(acces)) continue;
				size += (p = snprintf(b, CHANLEN + 3, "%s ", acces->chan)) > 0 ? p : (CHANLEN + 3);
				if(size >= 450)
				{
					csntc(nick, "%s%s ...", !first ? " Il a accs : " : "", chans);
					strcpy(chans, b); /* ajoute le suivant pour la prochaine*/
					first = 1;
					size = strlen(b);
				}
				else strcpy(&chans[tmps], b);
			}

			if(chans[0] != '\0') csntc(nick, "%s%s", !first ? " Il a accs : " : "", chans);
			else csntc(nick, " Il n'a aucun accs.");
		}
	}
	else if((ux = getuserinfo(user))) csntc(nick, " %s est un username enregistr. %s",
				ux->nick, IsAnAdmin(ux) ? " (\2Admin\2)" : "");

	csntc(nick, " Connect depuis %s sur \2%s",
				duration(time(NULL) - tmp->ttmco), tmp->serveur ? tmp->serveur->serv : bot.server);
	return 1;
}

int admin_user(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	char *user = parv[2];
	const char *arg = parv[1];
	anUser *u = NULL;
	anAccess *a, *a2;
	aNick *n;

	if(!strcasecmp(arg, "info"))
	{
		int mail, seen, date, auth, suspend, count, oubli, first, nopurge, cur = 0, nolimit = 0;
		time_t ttm = time(NULL);
		char tmp[75] = {0};

		if(*parv[2] == '-') user = "*";

		mail = getoption("-mail",parv,parc,2,0);
		seen = getoption("-seen",parv,parc,2,1);
		date = getoption("-date",parv,parc,2,1);
		count = getoption("-count",parv,parc,2,1);
		auth = getoption("-auth",parv,parc,2,-1);
		suspend = getoption("-suspend",parv,parc,2,-1);
		oubli = getoption("-oubli",parv,parc,2,-1);
		first = getoption("-first",parv,parc,2,-1);
		nopurge = getoption("-nopurge",parv,parc,2,-1);

		if(!strcasecmp("-all", parv[parc])) nolimit = 1;
		if(strlen(user) > NICKLEN) return 0;

		for(u=userhead;u;u=u->next)
		{
			if((!mail || !match(parv[mail], u->mail))
			&& (!seen || (ttm - u->lastseend) <= seen)
			&& (!date || ttm >= u->lastseend)
			&& (!auth || (auth && u->n) || (!auth && !u->n))
			&& (!suspend || IsSuspend(u))
			&& (!oubli || UOubli(u))
			&& (!first || UFirst(u))
			&& (!nopurge || UNopurge(u))
			&& (!match(user, u->nick)))
			{
				char chans[451] = {0}, chansw[500] = {0}, b[(REGCHANLEN + 20)];
				int size = 0, firstt = 0, sizew = 0, firstw = 0;
				cur++;
				if(((count && cur > count) || (!count && cur > MAXMATCHES)) && !nolimit) continue;
				csntc(nick, "Infos sur l'username \2%s\2 :", u->nick);
				csntc(nick, " Mail: %s", u->mail);

				if(UFirst(u)) csntc(nick, " En cours de validation, enregistrement il y a %s", duration(time(NULL) - u->lastseend));
				else csntc(nick, " Logu pour la dernire fois il y a %s", duration(time(NULL) - u->lastseend));
				if(IsAnAdmin(u)) csntc(nick, " \2Accs Administrateur.\2 (\002%d\2)", u->level);

				for(a = u->accesshead;a;a=a->next)
				{
					int p = snprintf(b, (REGCHANLEN + 20), "%s (%d) ", a->chan, a->level);
					if(AWait(a))
					{
						int tmps = sizew;
						sizew += p > 0 ? p : REGCHANLEN + 20;
						if(sizew >= 450) /* le dernier fait depasser le buffer */
						{
							csntc(nick, "%s%s ...", !firstw ? " Il a des propositions sur: " : "", chansw);
							strcpy(chansw, b); /* ajoute le suivant pour la prochaine*/
							firstw = 1;
							sizew = strlen(b);
						}
						else strcpy(&chansw[tmps], b);
					}
					else
					{
						int tmps = size;
						size += p > 0 ? p : REGCHANLEN + 20;
						if(size >= 450) /* le dernier fait depasser le buffer */
						{
							csntc(nick, "%s%s ...", !firstt ? " Il a accs : " : "", chans);
							strcpy(chans, b); /* ajoute le suivant pour la prochaine*/
							firstt = 1;
							size = strlen(b);
						}
						else strcpy(&chans[tmps], b);
					}
				}

				if(chans[0] != '\0') csntc(nick, "%s%s", !first ? " Il a accs : " : "", chans);
				else if(!firstt) csntc(nick, " Il n'a aucun accs.");
				if(chansw[0] != '\0') csntc(nick, "%s%s", !firstw ? " Il a des propositions sur: " : "", chansw);
				else if(!firstw) csntc(nick, " Il n'a aucune proposition d'access.");

				if((n = u->n)) csntc(nick, " %s%s est actuellement logu sous cet Username (%s@%s)",
					GetPrefix(n), n->nick, n->ident, n->host);
				else csntc(nick, " Personne n'est actuellement logu sous cet username");

				if(u->suspend) show_ususpend(nick, u);
				csntc(nick, " Options: %s", GetUserOptions(u));
				csntc(nick, " Last Login depuis %s", u->lastlogin ? u->lastlogin : "<Non Disponible>");

				if(!count || count > 1) csntc(nick, "-");
			}
		}

		if(cur)
		{
			if(cur > MAXMATCHES && !nolimit)
				csntc(nick, "[%d] Trop de matches trouves, restreignez votre recherche ou forcez avec '-all' en DERNIER argument.", MAXMATCHES);
			if(count && count < cur) sprintf(tmp,"(%d listes)", count);
			csntc(nick, "Un Total de %d entre%s trouve%s %s", cur, PLUR(cur), PLUR(cur), tmp);
		}
		else csntc(nick, "Aucun Username correspondant \2 %s\2 trouv.", user);
	}

	else if(!strcasecmp(arg, "match"))
	{
		char *p = parv[2];
		struct timeval tv;
		long ticks;
		struct Link *link = NULL;

		gettimeofday(&tv, NULL);
		ticks = tv.tv_usec;

		if(*p == '+' || *p == '-')
		{
			int w = 1, host = 0, nicki = 0, ident = 0, real = 0, join = 0, par = 2;
			int mode = 0, ac = 0, count = 0, crypt = 0, serv = 0, nolimit = 0;

			while(*p)
			{
				switch(*p)
				{
					case '+': w = 1; break;
					case '-': w = 0; break;
					case 'h':
							if((host = ++par) <= parc)
							{
								if(!w) host = -1 * host;
								break;
							}
							return csntc(nick, "Syntaxe %s MATCH [+|-]nughCcsam [args..]", RealCmd("user"));
					case 'n':
							if((nicki = ++par) <= parc)
							{
								if(!w) nicki = -1 * nicki;
								break;
							}
							return csntc(nick, "Syntaxe %s MATCH [+|-]nughCcsam [args..]", RealCmd("user"));
					case 'u':
							if((ident = ++par) <= parc)
							{
								if(!w) ident = -1 * ident;
								break;
							}
							return csntc(nick, "Syntaxe %s MATCH [+|-]nughCcsam [args..]", RealCmd("user"));
					case 'g':
							if((real = ++par) <= parc)
							{
								if(!w) real = -1 * real;
								break;
							}
							return csntc(nick, "Syntaxe %s MATCH [+|-]nughCcsam [args..]", RealCmd("user"));
					case 'c':
							if((join = ++par) <= parc)
							{
								if(!w) join = -1 * join;
								break;
							}
							return csntc(nick, "Syntaxe %s MATCH [+|-]nughCcsam [args..]", RealCmd("user"));
					case 'm':
							if((mode = ++par) <= parc)
							{
								if(!w) mode = -1 * mode;
								break;
							}
							return csntc(nick, "Syntaxe %s MATCH [+|-]nughCcsam [args..]", RealCmd("user"));
					case 'a':
							if((ac = ++par) <= parc)
							{
								if(!w) ac = -1 * ac;
								break;
							}
							return csntc(nick, "Syntaxe %s MATCH [+|-]nughCcsam [args..]", RealCmd("user"));
					case 's':
							if((serv = ++par) <= parc)
							{
								for(link=mainhub;link && strcasecmp(link->serv, parv[serv]);link=link->next);
								if(!link)
									return csntc(nick, "Serveur %s inconnu.", parv[serv]);

								if(!w) serv = -1 * serv;
								break;
							}
							return csntc(nick, "Syntaxe %s MATCH [+|-]nughCcsam [args..]", RealCmd("user"));
#ifdef HAVE_CRYPTHOST
					case 'C':
							if((crypt = ++par) <= parc)
							{
								if(!w) crypt = -1 * crypt;
								break;
							}
							return csntc(nick, "Syntaxe %s MATCH [+|-]nughCcsam [args..]", RealCmd("user"));
#endif
					default:
							return csntc(nick, "Syntaxe %s MATCH [+|-]nughCcsam [args..]", RealCmd("user"));
				}
				p++;
			}
			if(!strcasecmp("-all", parv[parc])) nolimit = 1;
			for(n=nickhead;n;n=n->next)
				if((!nicki || (nicki > 0 && !match(parv[nicki], n->nick)) || (nicki < 0 && match(parv[-1 * nicki], n->nick)))
					&& (!ident || (ident > 0 && !match(parv[ident], n->ident)) || (ident < 0 && match(parv[-1 * ident], n->ident)))
					&& (!real || (real > 0 && !match(parv[real], n->name)) || (real < 0 && match(parv[-1 * real], n->name)))
					&& (!serv || (serv > 0 && link == n->serveur) || (serv < 0 && link != n->serveur))
					&& (!host || (host > 0 && !match(parv[host], n->host)) || (host < 0 && match(parv[-1 * host], n->host)))
					&& (!mode || (mode > 0 && !match(parv[mode], GetModes(n))) || (mode < 0 && match(parv[-1 * mode], GetModes(n))))
					&& (!ac || (ac > 0 && n->user && !match(parv[ac], n->user->nick)) || (ac < 0 && n->user && match(parv[-1 * ac], n->user->nick)))
#ifdef HAVE_CRYPTHOST
					&& (!crypt || (crypt > 0 && !match(parv[crypt], n->crypt)) || (crypt < 0 && match(parv[-1 * crypt], n->crypt)))
#endif
					&& (!join || (join > 0 && getjoininfo(n, parv[join])) || (join < 0 && !getjoininfo(n, parv[-1 * join])))
					&& (++count <= MAXMATCHES || nolimit))
						csntc(nick, "Matching Nick: [%d] \2%s%s\2 -> %s@%s", count, GetPrefix(n), n->nick, n->ident, n->host);

			gettimeofday(&tv, NULL);
			if(count > MAXMATCHES && !nolimit)
				csntc(nick, "[%d] Trop de nicks trouvs, restreignez votre recherche ou forcez avec '-all' en DERNIER argument.", MAXMATCHES);

			csntc(nick, "Fin de la Recherche: %d matche%s trouve%s. (Effectue en %6.3f ms)",
				count, PLUR(count), PLUR(count), (float) (tv.tv_usec - ticks)/1000);
		}
		else return csntc(nick, "Syntaxe %s MATCH [+|-]nughCcsam [args..]", RealCmd("user"));
	}

	else if(!strcasecmp(arg, "suspend"))
	{
		if(!strcasecmp(nick->user->nick, user))
			return csntc(nick, "Vous ne devriez pas vous suspendre.. (Utilisez la commande \2%s\2)", RealCmd("suspendme"));

		if(!(u = ParseNickOrUser(nick, user))) return 0;

		if(IsAnAdmin(u) && u->level >= nick->user->level)
			return csntc(nick, "Vous ne pouvez pas suspendre un Admin de niveau suprieur ou gal.");

		if(!IsSuspend(u) && ((parc == 3 && *parv[3] == '%') || parc < 3))
			return csntc(nick, "Veuillez prciser une raison pour suspendre cet UserName.");

		if(!IsSuspend(u))
		{
			time_t timeout = 0;

			if(*parv[3] == '%' && !(timeout = convert_duration(++parv[3])))
				return csntc(nick, "Dure incorrecte, le format est %%<XjXhXm> X tant le nombre respectif d'units.");

			do_user_suspend(u, parv2msg(parc, parv, timeout ? 4 : 3, 250), nick->user->nick, timeout, time(NULL));
			show_ususpend(nick, u);

			if((n = u->n))
			{
				csntc(n, "Votre Username vient d'tre suspendu par l'Admin %s.", nick->nick);
				cs_account(n, NULL);
			}
		}
		else
		{
			if(getoption("-nolog", parv, parc, 2, -1))
			{
				free(u->suspend);
				u->suspend = NULL;
			}
			else u->suspend->expire = -1;

			csntc(nick, "L'Username \2%s\2 n'est plus suspendu.", u->nick);
		}
		write_anuser(u);
	}

	else if(!strcasecmp(arg, "cantregchan"))
	{
		if(!strcasecmp(nick->user->nick, user))
			return csntc(nick, "Vous ne voulez plus pouvoir enregistrer de chan ?");

		if(!(u = ParseNickOrUser(nick, user))) return 0;

		if(IsAnAdmin(u))
			return csntc(nick, "Vous ne pouvez pas empecher un Admin d'enregistrer des salons.");

		if(!CantRegChan(u))
		{
			time_t timeout = 0;

			if(parc >= 3 && *parv[3] == '%' && !(timeout = convert_duration(++parv[3])))
				return csntc(nick, "Dure incorrecte, le format est %%<XjXhXm> X tant le nombre respectif d'units.");

			u->cantregchan = timeout ? (time(NULL) + timeout) : 0;
			csntc(nick, "%s ne peut pas enregistrer de salon%s%s.", u->nick,
				(u->cantregchan > 0) ? " jusqu'au " : "", (u->cantregchan > 0) ? get_time(u->cantregchan) : "");
			if((n = u->n))
			{
				if(timeout)
					csntc(n, "Vous ne pouvez plus enregistrer de salon jusqu'au %s.", get_time(u->cantregchan));
				else
					csntc(n, "Vous ne pouvez plus enregistrer de salon jusqu' ce qu'un admin vous le permette.");
			}
		}
		else
		{
			u->cantregchan = -1;
			csntc(nick, "L'Username \2%s\2 peut maintenant enregistrer des salons.", u->nick);
		}
		write_anuser(u);
	}

	else if(!strcasecmp(arg, "mail"))
	{
		if(parc < 3 || !IsValidMail(parv[3]))
			return csntc(nick, "Veuillez prciser un Mail valide.");

		if(!(u = ParseNickOrUser(nick, user))) return 0;

		Strncpy(u->mail, parv[3], MAILLEN);
		csntc(nick, "Le mail de %s a t chang en \2%s", u->nick, parv[3]);
		write_anuser(u);
	}

	else if(!strcasecmp(arg, "newpass"))
	{
		char p[15];
		if(parc < 3 || strlen(parv[3]) < 6)
			return csntc(nick, "Veuillez entrer un pass (Valide).");

		if(!(u = ParseNickOrUser(nick, user))) return 0;

		if(IsAnAdmin(u) && u->level >= nick->user->level && u != nick->user)
			return csntc(nick, "Vous ne pouvez pas changer le pass d'un Admin de niveau suprieur ou gal.");

		Strncpy(p, parv[3], sizeof p - 1);
		strncpy(u->passwd, mkpass(p), 20);
		csntc(nick, "Le mot de pass de \2%s\2 a bien t chang.", user);
		write_anuser(u);
	}

	else if(!strcasecmp(arg, "newnick"))
	{
		char *newusr = NULL;
		anUser *utemp = userhead;

		if(parc < 3 || strlen(parv[3]) > NICKLEN || !IsValidNick(parv[3]))
			return csntc(nick, "Veuillez entrer un username (Valide).");

		newusr = parv[3];
		for(;utemp;utemp=utemp->next)
		{
			if(!strcasecmp(utemp->nick, newusr))
				return csntc(nick, "%s est un username dj utilis.", newusr);

			if(!strcasecmp(utemp->nick, user)) u = utemp ;
		}

		if(!u) return csntc(nick, NOSUCHUSER, user);

		if(IsAnAdmin(u) && u->level >= nick->user->level && u != nick->user)
			return csntc(nick, "Vous ne pouvez pas changer l'username d'un Admin de niveau suprieur ou gal.");

		File_UserDel(u->nick);
		Strncpy(u->nick, newusr, NICKLEN);
		if(u->n) cs_account(u->n, newusr);
		csntc(nick, "L'username de %s a t chang en %s.", user, newusr);
		write_anuser(u);
		write_userlist();
	}

	else if(!strcasecmp(arg, "del"))
	{
#ifdef HAVE_TRACK
		struct track *track;
#endif
		if(!strcasecmp(nick->user->nick, user))
			return csntc(nick, "Vous ne devriez pas vous deluser.. (Utilisez la commande \2%s\2)", RealCmd("drop"));

		if(!(u = ParseNickOrUser(nick, user))) return 0;

		if(IsAnAdmin(u) && u->level >= nick->user->level)
			return csntc(nick, "Vous ne pouvez supprimer un Username d'Admin de niveau suprieur ou gal.");

#ifdef HAVE_TRACK
		if((track = istrack(u)))
		{
			csntc(track->tracker, "[\2Track\2] L'UserName %s que vous trackez vient d'tre supprim par %s.", track->tracked->nick, nick->user->nick);
			del_track(u);
		}
#endif
		if((n = u->n))
		{
			char raison[200] = {0};
			if(parc > 2) parv2msgn(parc, parv, 3, raison, sizeof raison);

			cs_account(n, NULL);
			csntc(n, "Votre Username vient d'tre supprim par l'Admin %s %s", nick->nick, raison);
		}

		csntc(nick, "L'username %s a bien t supprim.", u->nick);

		for(a = u->accesshead;a;a = a2)
		{
			a2 = a->next;
			if(a->level == OWNERLEVEL)
			{
				char tmp[400];
				snprintf(tmp, sizeof tmp, "Salon %s desenregistr par %s@%s (\2Suppression de l'username de l'owner\2)",
					a->chan, nick->nick, nick->user->nick);
				del_chan(a->c, tmp);
			}
		}
		del_regnick(u);
		write_userlist();
	}
#ifdef SQLLOG
	else if(!strcasecmp(arg, "historique"))
	{
		time_t date = 0;
		MYSQL_RES *result;
		MYSQL_ROW row;
		int cmd, chan;
		char tmp[150] = "SELECT * FROM usercmdslog WHERE user='%s' AND TS>=%T";

		if(!(u = ParseNickOrUser(nick, user))) return 0;
		if(parc < 2) return csntc(nick, "Syntaxe: %s HISTORIQUE <username> [%%XjXh] [-cmd <cmd> -chan]", RealCmd("user"));
		if(parc >= 3 && *parv[3] == '%' && !(date = convert_duration(++parv[3])))
			return csntc(nick, "Dure incorrecte, le format est %%<XjXhXm> X tant le nombre respectif d'units.");

		if((chan = getoption("-chan", parv, parc, 2, -1))) strcpy(tmp, "SELECT * FROM chancmdslog WHERE user='%s' AND TS>=%T");
		if((cmd = getoption("-cmd", parv, parc, 2, 0))) strcat(tmp, " AND cmd='%s'");

		if(sql_query(tmp, u->nick,	date ? time(NULL) - date : 0, cmd ? parv[cmd] : "") < 0)
			return csntc(nick, "La requte SQL a choue.");

		if(!(result = mysql_store_result(bot.sql_id)) || !(row = mysql_fetch_row(result)))
			return csntc(nick, "Aucune entre trouve.");

		if(date) csntc(nick, "Commandes effectues par %s depuis %s.", u->nick, duration(date));
		else csntc(nick, "Commandes effectues par %s.", u->nick);
		for(;row;row = mysql_fetch_row(result))
		{
			if(chan) csntc(nick, "%s: \2%s\2 [%s] sur \2%s", get_time(strtoul(row[2], NULL, 10)), row[3], NONE(row[4]), row[1]);
			else csntc(nick, "%s: commande \2%s\2 [%s]", get_time(strtoul(row[1], NULL, 10)), row[2], NONE(row[3]));
		}
		mysql_free_result(result);
	}
#endif
	else if(!strcasecmp(arg, "stats"))
	{
		int memn = getoption("-mem",parv,parc,2,-1);
		int cmds = getoption("-cmds",parv,parc,2,0);
		int traffic = getoption("-traffic",parv,parc,2,-1);
		int all = getoption("-all",parv,parc,2,-1);

		if(memn || all)
		{
			int memm = 0, usr = 0, chs = 0, usra = 0, ni = 0, maxbans, maxaccess, ma, mb;
			aBan *ban;
			aJoin *j;
			struct badnicks *bn;
			struct badchans *bc;
			struct ignore *ig;
			aLink *lp;

			maxbans = getoption("-maxbans", parv, parc, 2, 1);
			maxaccess = getoption("-maxaccess", parv, parc, 2, 1);
			maxbans = maxbans ? maxbans : WARNACCESS;
			maxaccess = maxaccess ? maxaccess : WARNACCESS;

			uptime(nick, chaninfo, parc, parv);

			for(n=nickhead;n;n = n->next, ni++)
				for(j = n->joinhead;j;j = j->next) memm += sizeof(aJoin);
			memm += ni * sizeof(aNick);

			for(u=userhead;u;u = u->next, usr++)
			{
				if(u->suspend) memm += sizeof(struct suspendinfo);
				if(u->lastlogin) memm += strlen(u->lastlogin);
				if(u->n) usra++;
			}
			memm += usr * sizeof(anUser);

			for(chaninfo = chanhead;chaninfo;chaninfo = chaninfo->next)
			{
				chs++;
				if(chaninfo->suspend) memm += sizeof(struct suspendinfo);
				if(chaninfo->motd) memm += strlen(chaninfo->motd);
				mb = ma = 1;
				for(ban=chaninfo->banhead;ban;ban = ban->next, mb++) if(ban->raison) memm += strlen(ban->raison);
				memm += mb * sizeof(aBan);
				if(mb >= maxbans) csntc(nick, "Warning Bans Limite: \2\00304%d\2\3 Bans sur %s", mb, chaninfo->chan);

				for(lp = chaninfo->access;lp;lp=lp->next, ma++) if(lp->value.a->info) memm += strlen(lp->value.a->info);
				memm += ma * sizeof(anAccess);
				if(ma >= maxaccess) csntc(nick, "Warning Acces Limite: \2\00304%d\2\3 Accs sur %s", ma, chaninfo->chan);
			}
			memm += chs * sizeof(aChan);

			for(bn=badnhead;bn;bn = bn->next) memm += sizeof(struct badnicks);
			for(bc=badchead;bc;bc = bc->next) memm += sizeof(struct badchans);
			for(ig=ignorehead;ig;ig=ig->next) memm += sizeof(struct ignore);
			memm += sizeof(struct robot) + sizeof(struct bots) + sizeof(struct Link);

			csntc(nick, "Memoire Utilise pour les Users/Chans: %10.3f KB", memm / 1024.0);
			csntc(nick, "Il y a %d Usernames enregistrs et %d Chans.", usr, chs);
			csntc(nick, "%d Chatteurs connects, dont %4.1f %% actuellement logus.",
						ni, (usra / (float) ni) * 100);
		}
		if(cmds || all)
		{
			int x = 0, adm = 0, usr = 0;

			for(;cs_cmds[x].cmd[0]!='\0';x++)
			{
				if(cs_cmds[x].level > 1 && cs_cmds[x].level < 5) adm += cs_cmds[x].used;
				else usr += cs_cmds[x].used;
				if(cmds && !match(parv[cmds],cs_cmds[x].cmd) && cs_cmds[x].cmd[0]!='\1')
					csntc(nick, "- %s (\002%d\2)", cs_cmds[x].cmd, cs_cmds[x].used);
			}
			csntc(nick, "Un total de %d commandes utilises, dont %d Admins (Ratio: %5.2f%)",
				(adm + usr), adm, (adm / (float) (usr + adm)) * 100);
		}
		if(traffic || all)
		{
			float up, down;
			int mbu = 0, mbd = 0;

			up = dataS/1024.0;
			down = dataQ/1024.0;
			if(up >= 1024)
			{
				up = up/1024.0;
				mbu = 1;
			}
			if(down >= 1024)
			{
				down = down/1024.0;
				mbd = 1;
			}
			csntc(nick, "Traffic: Up: \2%10.3f %s\2 Down: \2%10.3f %s\2", up, mbu ? "MB":"KB", down, mbd ? "MB":"KB");
			csntc(nick, "Traffic Actuel: %10.3f Ko/s", (float) bot.lastbytes / ((time(NULL) - bot.lasttime) * 1024.0));
		}
		if(!all && !memn && !traffic && !cmds) csntc(nick, "Option de stats non valide");
	}
	else if(!strcasecmp(arg, "nopurge"))
	{
		if(!(u = ParseNickOrUser(nick, user))) return 0;

		if(parc < 3) ToggleFlag(&u->flag, U_NOPURGE);
		else
		{
			if(!strcasecmp(parv[3], "ON")) SetUNopurge(u);
			else if(!strcasecmp(parv[3], "OFF")) DelUNopurge(u);
			else return csntc(nick, "La valeur doit tre ON ou OFF");
		}
		csntc(nick, "Le NOPURGE de %s est %sactif", u->nick, UNopurge(u) ? "" : "in");
		write_anuser(u);
	}
	else if(!strcasecmp(arg, "checkpass"))
	{
		if(parc < 3)
			return csntc(nick, "Syntaxe: %s CHECKPASS <username|%%nick> <pass>", RealCmd("user"));

		if(!(u = ParseNickOrUser(nick, user))) return 0;

		if(!checkpass(parv[3], u)) csntc(nick, "Le mot de passe n'est \2PAS\2 correct !");
		else csntc(nick, "Le mot de passe \2EST\2 correct.");
	}
	else return csntc(nick, "%s n'est pas une option valide.", arg);
	return 1;
}

void do_user_suspend(anUser *user, const char *raison, const char *nick, time_t expire, time_t debut)
{
	if(!user->suspend) user->suspend = calloc(1, sizeof(struct suspendinfo));
	Strncpy(user->suspend->raison, raison, 250);
	Strncpy(user->suspend->from, nick, NICKLEN);
	user->suspend->debut = debut;
	user->suspend->expire = expire;
	return;
}

void show_ususpend(aNick *nick, anUser *user)
{
	if(!user->suspend) return; /* on aurait jamais du l'envoyer l*/
	if(IsSuspend(user))
	{
		char buf[200] = {0};
		Strncpy(buf, get_time(user->suspend->debut), sizeof buf - 1);
		csntc(nick, "L'UserName %s \2EST\2 suspendu par %s (le %s). Expire %s", user->nick, user->suspend->from, buf,
			user->suspend->expire ? get_time((user->suspend->debut + user->suspend->expire)) : "Jamais");
	}
	else csntc(nick, "L'UserName %s \2ETAIT\2 suspendu par %s", user->nick, user->suspend->from);
	csntc(nick, "Raison: %s", user->suspend->raison);
	return;
}
