/* src/cs_register.c - Enregistrement de salon
 * Copyright (C) 2002-2003 Inter System
 *
 * contact: Progs@Inter-System.Net
 *          Cesar@Inter-System.Net
 *          kouak@kouak.org
 * site web: http://coderz.inter-system.net
 *
 * Services pour serveur IRC. Support sur IrcProgs et IrCoderZ
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <unistd.h>
#include "main.h"

CVSINFO("$Id: cs_register.c,v 1.31 2003/08/02 01:56:01 romexzf Exp $");

/*
 * register_chan
 *
 * parv[1] = salon
 * parv[2-parc] = description
 */
int register_chan(aNick *nick, aChan *c, int parc, char **parv)
{
	char *salon = parv[1], description[200] = {0}, *ptr;
	aJoin *chan;

	if(!chan_check(salon, nick)) return 0;
	if(!nick->user)
		return csntc(nick, "Pour utiliser cette commande vous devez vous identifier sous votre username (Commande \2%s\2)", RealCmd("login"));

	if(CantRegChan(nick->user))
		return csntc(nick, "Vous ne pouvez pas enregistrer de salon%s%s.",
				(nick->user->cantregchan > 0) ? " jusqu'au " : "", (nick->user->cantregchan > 0) ? get_time(nick->user->cantregchan) : "");

	parv2msgn(parc, parv, 2, description, 200);

	if(strlen(description) < 12)
		return csntc(nick, "La longueur de la description doit tre de plus de 12 charactres.");

	if((ptr = IsAnOwner(nick->user)))
		return csntc(nick, "\2Vous tes dj l'owner de %s.", ptr);

	if(getchaninfo(salon)) return csntc(nick, "\2%s est dj enregistr", salon);

	chan = getjoininfo(nick, salon);
	if(!chan || !chan->is_op)
		return csntc(nick, "Vous devez tre Op sur %s pour l'enregistrer.", salon);

	c = add_chan(salon, "", description, "+nt", "", "", "", "");
	add_access(nick->user, salon, OWNERLEVEL, (A_OP | A_PROTECT), time(NULL));

	csjoin(c);
	putlog(LOG_CHANS, "REGCHAN %s par %s@%s (%s)\n", salon, nick->nick, nick->user->nick, description);
	csntc(nick, "Le salon %s est maintenant enregistr et vous appartient", salon);

	append_file(CHANS_FILE,c->chan);
	write_achan(c);
	write_anuser(nick->user);
	return 1;
}

/*
 * ren_chan
 *
 * parv[1] = chan
 * parv[2] = nouveau chan
 */
int ren_chan(aNick *nick, aChan *c, int parc, char **parv)
{
	aChan *c2;
	aLink *acces;
	aJoin *j;
	char *chan = parv[1], *newchan = parv[2], path1[250], path2[250], old[200], new[200];

	if(c->flag & C_ALREADYRENAME && !IsAnAdmin(nick->user))
		return csntc(nick, "Vous avez dj renomm votre salon rcemment.");

	if(!chan_check(newchan, nick)) return 0;

	if((c2 = getchaninfo(newchan)))
		return csntc(nick, "Le salon \2%s\2 est dj enregistr", c2->chan);

	if(!(j = getjoininfo(nick, newchan)) || !j->is_op)
		return csntc(nick, "Vous devez tre Op sur %s pour l'enregistrer.", newchan);

	snprintf(path1, sizeof path1, "Nom chang en \2%s\2 - %s@%s", newchan, nick->nick, nick->user->nick);
	cspart(c, path1);

	putlog(LOG_CHANS, "RENCHAN %s %s par %s@%s\n", c->chan, newchan, nick->nick, nick->user->nick);
	Strncpy(c->chan, newchan, REGCHANLEN);
	csjoin(c);
	write_chanlist();

	for(acces = c->access;acces;acces=acces->next)
	{
		strcpy(acces->value.a->chan, newchan);
		write_anuser(acces->value.a->user);
	}

	c->flag |= C_ALREADYRENAME;
	conv_char(chan, old);
	conv_char(newchan, new);
	snprintf(path1, 250, DBDIR "/chans/%s", old);
	snprintf(path2, 250, DBDIR "/chans/%s", new);
	rename(path1, path2);

	csntc(nick, "Le nom du salon %s est maintenant %s", chan, newchan);
	return 1;
}

/*
 * unreg_chan
 *
 * parv[1] = salon
 * parv[parc-1] = raison
 */
int unreg_chan(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	char *salon = parv[1], raison[150], tmp[400];
	anAccess *a;

	if(!nick->user || !(a = GetAccessIbyUserI(nick->user, salon)) || a->level != OWNERLEVEL)
		return csntc(nick, "Vous devez tre le propritaire du salon pour le supprimer.");

	if(!CWantUnreg(chaninfo))
	{
		SetCWantUnreg(chaninfo);
		csntc(nick, "Etes vous sur de vouloir dsenregistrer votre salon (%s), cette opration est \2irrversible\2.", chaninfo->chan);
		csntc(nick, "Pour annuler, tapez \2/%s %s %s NON\2 pour confirmer, tapez \2/%s %s %s OUI\2",
				cs.nick, RealCmd("unreg"), chaninfo->chan, cs.nick, RealCmd("unreg"), chaninfo->chan);
		return 1;
	}
	if(parc < 2 || (strcasecmp(parv[2],"oui") && strcasecmp(parv[2],"non")))
		return csntc(nick, "Salon en cours d'unreg: pour annuler, tapez \2/%s %s %s NON\2 pour confirmer, tapez \2/%s %s %s OUI\2",
				cs.nick, RealCmd("unreg"), chaninfo->chan, cs.nick, RealCmd("unreg"), chaninfo->chan);

	if(!strcasecmp(parv[2],"non"))
	{
		csntc(nick, "Procdure d'unreg annule.");
		DelCWantUnreg(chaninfo);
		return 1;
	}
	if(parc > 2) parv2msgn(parc, parv, 3, raison, 150);
	else strcpy(raison, "Aucune raison");

	csntc(nick, "Le salon %s a bien t dsenregistr", salon);
	snprintf(tmp, 400, "Salon %s desenregistr par %s@%s (%s)", salon, nick->nick, nick->user->nick, raison);
	del_chan(chaninfo, tmp);
	return 1;
}
