/* src/fichiers.c - Lecture/criture des donnes
 * Copyright (C) 2002-2003 Inter System
 *
 * contact: Progs@Inter-System.Net
 *          Cesar@Inter-System.Net
 *          kouak@kouak.org
 * site web: http://coderz.inter-system.net
 *
 * Services pour serveur IRC. Support sur IrcProgs et IrCoderZ
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "fichiers.h"

CVSINFO("$Id: fichiers.c,v 1.76 2003/08/02 01:56:01 romexzf Exp $");

int load_users(void)
{
	FILE *fp, *fp1;
	char buff[100];
	int adm = 0, fileversion = 1, stats = 0;
	anUser *u = NULL;
	anAccess *a;

	if(!(fp = fopen(USERS_FILE, "r")))
	{
		premiere = 1;
		return 0;
	}
	while(fgets(buff, sizeof buff, fp))
	{
		char nuser[120] = {0}, *user, buff1[500] = {0};
		stats++;
		strip_newline(buff);
		user = strtok(buff, " ");
		conv_char(user, nuser);
		sprintf(buff1, DBDIR "/usr/%s", nuser);
		if(!(fp1 = fopen(buff1, "r"))) continue;

		while(fgets(buff1, 500, fp1))
		{
			char *field = NULL;
			strip_newline(buff1);
			if((field = strchr(buff1, ' '))) *field++ = 0;
			else continue;

			if(!strcmp(buff1, "VERSION")) fileversion = atoi(field);
			else if(!strcmp(buff1, "NICK"))
			{
				char *nick, *pass, *level, *suspendu = NULL, *mail, *lastseend = NULL, *voted = NULL, *last = NULL;
				char *cantregchan = NULL;
				int flag = 0;
				nick = strtok(field, " ");
				pass = strtok(NULL, " ");
				level = strtok(NULL, " ");
				if(fileversion >= 12)
				{
					suspendu = strtok(NULL, " ");
					lastseend = strtok(NULL, " ");
					flag = atoi(strtok(NULL, " "));
					voted = strtok(NULL, " ");
					mail = strtok(NULL, " ");
					last = strtok(NULL, " ");
					if(last && *last == '-')
					{
						cantregchan = last;
						last = NULL;
					}
					if(fileversion >= 17) cantregchan = strtok(NULL, " ");
#ifdef USE_NICKSERV
					if(fileversion == 18)
					{
						int protect = 0;
						protect = atoi(strtok(NULL, " "));
						if(protect == 1) flag |= U_PNICK;
						else if(protect == 2) flag |= U_PKILL;
					}
#endif
				}
				else
				{
					char *want_x = NULL, *nopurge = NULL, *oubli = NULL, *first = NULL, *accesspolicy = NULL;
					char *setkill, *mynick = NULL;
					setkill = strtok(NULL, " ");
					lastseend = strtok(NULL, " ");
					suspendu = strtok(NULL, " ");

					if(fileversion >= 3) mynick = strtok(NULL, " ");
					if(fileversion >= 4) voted = strtok(NULL, " ");
					if(fileversion >= 5) want_x = strtok(NULL, " ");
					if(fileversion >= 6) nopurge = strtok(NULL, " ");
					if(fileversion >= 9) oubli = strtok(NULL, " ");
					if(fileversion >= 10) first = strtok(NULL, " ");
					if(fileversion >= 11) accesspolicy = strtok(NULL, " ");
					mail = strtok(NULL, " ");

#ifdef USE_NICKSERV
					if(mynick && is_num(mynick) && atoi(mynick) && setkill && is_num(setkill) && atoi(setkill))
						flag |= (atoi(setkill)) ? U_PKILL : U_PNICK;
#endif
					if(want_x && is_num(want_x) && atoi(want_x)) flag |= U_WANTX;
					if(oubli && is_num(oubli) && atoi(oubli)) flag |= U_OUBLI;
					if(first && is_num(first) && atoi(first)) flag |= U_FIRST;
					if(nopurge && is_num(nopurge) && atoi(nopurge)) flag |= U_NOPURGE;

					if(accesspolicy && is_num(accesspolicy))
					{
						if(atoi(accesspolicy) == 1) flag |= U_POKACCESS;
						else if(!atoi(accesspolicy)) flag |= U_PREJECT;
						else if(atoi(accesspolicy) == 2) flag |= U_PACCEPT;
					}
				}
				u = add_regnick(nick, pass, lastseend ? atol(lastseend) : 0, atoi(level), flag, mail, (voted && is_num(voted)) ? atoi(voted) : 0);
				if(last && *last && *last != '0') str_dup(&u->lastlogin, last);

				if(cantregchan && is_num(cantregchan)) u->cantregchan = strtol(cantregchan, NULL, 10);
				if(is_num(level) && atoi(level) > 1) adm = 1;
			}

			else if(!strcmp(buff1, "SUSPEND") && *field && fileversion >= 16)
			{ /* UserName TimeStamp :raison */
				char *from, *expire, *raison, *debut;
				raison = strchr(field, ':');
				from = strtok(field, " ");
				expire = strtok(NULL, " ");
				debut = strtok(NULL, " ");
				do_user_suspend(u, ++raison, from, strtol(expire, NULL, 10), strtol(debut, NULL, 10));
			}

#ifdef USE_MEMOSERV
			else if(!strcmp(buff1, "MEMO"))
			{
				char *de, *date, *read = NULL, *tmp = strchr(field, ':');

				de = strtok(field, " ");
				date = strtok(NULL, " ");
				if(fileversion >= 15) read = strtok(NULL, " ");
				add_memo(u, de, atoi(date), ++tmp, read ? atol(read) : 0);
			}
#endif
			else if(!strcmp(buff1, "ACCESS"))
			{
				int flaga = 0;
				char *tmp = strchr(field, ':'), *chan, *level, *lastseend = NULL;

				chan = strtok(field, " ");
				level = strtok(NULL, " ");
				if(fileversion >= 13) flaga = atoi(strtok(NULL, " "));
				else
				{
					char *autoop, *autovoice, *protect, *suspendu;
					if((autoop = strtok(NULL, " ")) && is_num(autoop) && atoi(autoop)) flaga |= A_OP;
					if((autovoice = strtok(NULL, " ")) && is_num(autovoice) && atoi(autovoice)) flaga |= A_VOICE;
					if((suspendu = strtok(NULL, " ")) && is_num(suspendu) && atoi(suspendu)) flaga |= A_SUSPEND;
					if((protect = strtok(NULL, " ")) && is_num(protect) && atoi(protect)) flaga |= A_PROTECT;
				}
				lastseend = strtok(NULL, " ");
				a = add_access(u, chan, atoi(level), flaga, lastseend ? atol(lastseend) : 0);
				if(a && tmp && *++tmp) str_dup(&a->info, tmp);
			}
			else if(fileversion >= 2 && !strcmp(buff1, "WAITACCESS"))
			{
				char *chan, *level;
				chan = strtok(field, " ");
				level = strtok(NULL, " ");
				add_access(u, chan, atoi(level), A_WAITACCESS, 0);
			}
		}
		fclose(fp1);
	}
	fclose(fp);
	if(!adm) printf("Aucun Admin localis dans la Base de Donnes!!\n");
	return stats;
}

void write_userlist(void)
{
	FILE *fp;
	anUser *user = userhead;

	if(!(fp = fopen(USERS_FILE, "w"))) return;

	for(;user;user=user->next) fprintf(fp, "%s\n", user->nick);

	fclose(fp);
	return;
}

void write_anuser(anUser *u)
{
#ifdef USE_MEMOSERV
   struct memos *memo;
#endif
   anAccess *a;
   FILE *fp1;
   char nuser[120] = {0}, buff[140];

   conv_char(u->nick, nuser);
   snprintf(buff, 140, DBDIR "/usr/%s", nuser);
   if(!(fp1 = fopen(buff, "w"))) return;

	fprintf(fp1, "VERSION %d\n", USRS_VERSION);
#ifdef HAVE_VOTE
	fprintf(fp1, "NICK %s %s %d %d %lu %d %d %s %s %ld\n", u->nick, u->passwd, u->level,
		0, u->lastseend, u->flag, u->vote, u->mail, u->lastlogin ? u->lastlogin : "0", u->cantregchan);
#else
	fprintf(fp1, "NICK %s %s %d %d %lu %d %d %s %s %ld\n", u->nick, u->passwd,
		u->level, 0, u->lastseend, u->flag, 0, u->mail, u->lastlogin ? u->lastlogin : "0", u->cantregchan);
#endif
	if(u->suspend) fprintf(fp1, "SUSPEND %s %ld %ld :%s\n", u->suspend->from, u->suspend->expire, u->suspend->debut, u->suspend->raison);

#ifdef USE_MEMOSERV

	for(memo = u->memohead;memo;memo=memo->next) fprintf(fp1, "MEMO %s %d %d :%s\n", memo->de, memo->date, memo->read, memo->message);
#endif

    for(a = u->accesshead;a;a = a->next)
    	fprintf(fp1, "ACCESS %s %d %d %lu :%s\n", a->chan, a->level, a->flag, a->lastseen == 1 ? time(NULL) : a->lastseen, NONE(a->info));

    fclose(fp1);
    return;

}

void write_users(void)
{
   anUser *user = userhead;
   for(;user;user=user->next) write_anuser(user);
}

void write_chanlist(void)
{
	FILE *fp = fopen(CHANS_FILE, "w");
	aChan *chan = chanhead;

	if(!fp) return;

	for(;chan;chan=chan->next) fprintf(fp, "%s\n", chan->chan);

	fclose(fp);
	return;
}

void write_achan(aChan *chan)
{
	FILE *fchan;
	aBan *ban;
	char nchan[200] = {0}, buff[230];

	conv_char(chan->chan, nchan);
	snprintf(buff, 230, DBDIR "/chans/%s", nchan);
	if(!(fchan = fopen(buff, "w"))) return;

	fprintf(fchan, "TOPIC %s\nDEFMODES %s\nDEFTOPIC %s\n", chan->topic, chan->defmodes, chan->deftopic);
	fprintf(fchan, "DESCRIPTION %s\nWELCOME %s\n", chan->description, chan->welcome);
	fprintf(fchan, "OPTIONS %d %d %d %d %lu %d %d\n", (chan->flag & ~C_JOINED), chan->banlevel,
		chan->bantype, chan->cml, chan->bantime, chan->limit_min, chan->limit_inc);
	fprintf(fchan, "MOTD %s\nURL %s\n", NONE(chan->motd), chan->url);
	if(chan->suspend)
		fprintf(fchan, "SUSPEND %s %ld %ld :%s\n", chan->suspend->from, chan->suspend->expire, chan->suspend->debut, chan->suspend->raison);

	fclose(fchan);
	snprintf(buff, 230, DBDIR "/bans/%s", nchan);

	if(!chan->banhead)
	{
		remove(buff);
		return;
	}
	if(!(fchan = fopen(buff, "w"))) return;

	for(ban = chan->banhead;ban;ban=ban->next)
		fprintf(fchan, "%s %s %lu %lu %d :%s\n", ban->mask, ban->de, ban->debut, ban->fin, ban->level, ban->raison);

	fclose(fchan);
	return;
}

void write_bans(aChan *chan)
{
	FILE *fchan;
	aBan *ban;
	char nchan[200], buff[230];

	conv_char(chan->chan, nchan);
	snprintf(buff, 230, DBDIR "/bans/%s", nchan);

	if(!chan->banhead) /* au lieu d'crire un fichier pour keud, on peut kiter direct, et supprimer le fichier*/
	{		      /* si il existe pour faire le mnage :p --Progs*/
		remove(buff);
		return;
	}

	if(!(fchan = fopen(buff, "w"))) return;
	for(ban = chan->banhead;ban;ban=ban->next)
		fprintf(fchan, "%s %s %lu %lu %d :%s\n", ban->mask, ban->de, ban->debut, ban->fin, ban->level, ban->raison);

	fclose(fchan);
	return;
}

int count_char(const char *buf, char c)
{
	int count = 0;
	while(*buf) if(*buf++ == c) count++;
	return count;
}

int load_chans(void)
{
	FILE *fp, *fp1;
	char buff[250], *tmp = NULL;
	int stats = 0;
	aChan *cc = NULL;

	if(!(fp = fopen(CHANS_FILE, "r")))
	{
		premiere = 1;
		return 0;
	}
	while(fgets(buff, sizeof buff, fp))
	{
		char *chan, nchan[200] = {0}, buff1[500] = {0}, chanurl[101] = {0}, motd[TOPICLEN + 1] = {0}, deftopic[TOPICLEN + 1] = {0};
		char description[DESCRIPTIONLEN + 1] = {0}, welcome[TOPICLEN + 1] = {0}, topic[TOPICLEN + 1] = {0}, defmodes[31] = {0};
		int flag = 0, chmodeslevel = 0, banlevel = 0, bantype = 0, limit_min = 0, limit_inc = 0;
		unsigned long bandefault = 0;

		stats++;
		strip_newline(buff);
		chan = strtok(buff, " ");
		conv_char(chan, nchan);
		snprintf(buff1, 230, DBDIR "/chans/%s", nchan);
		if(!(fp1 = fopen(buff1, "r"))) continue;

		while(fgets(buff1, 500, fp1))
		{
			char *field = NULL;
			strip_newline(buff1);
			if((field = strchr(buff1, ' '))) *field++ = 0;
			else continue;

			if(!strcmp(buff1, "TOPIC")) Strncpy(topic, field, TOPICLEN);
			else if(!strcmp(buff1, "DEFMODES")) Strncpy(defmodes, field, sizeof defmodes -1);
			else if(!strcmp(buff1, "DEFTOPIC")) Strncpy(deftopic, field, TOPICLEN);
			else if(!strcmp(buff1, "DESCRIPTION")) Strncpy(description, field, DESCRIPTIONLEN);
			else if(!strcmp(buff1, "WELCOME")) Strncpy(welcome, field, TOPICLEN);
			else if(!strcmp(buff1, "OPTIONS"))
			{
				if(count_char(field, ' ') > 6)/* vieux format*/
				{
					int setwelcome = 0, strictop = 0, locktopic = 0, nobans = 0, noops = 0, autoinvite = 0;
					sscanf(field, "%d %d %d %d %d %d %d %d %d %lu", &setwelcome, &strictop,	&locktopic,
						&nobans, &noops, &banlevel, &bantype, &autoinvite, &chmodeslevel, &bandefault);
					if(setwelcome) flag |= C_SETWELCOME;
					if(nobans) flag |= C_NOBANS;
					if(noops) flag |= C_NOOPS;
					if(locktopic) flag |= C_LOCKTOPIC;
					if(strictop) flag |= C_STRICTOP;
					if(autoinvite) flag |= C_AUTOINVITE;
				}
				else sscanf(field, "%d %d %d %d %lu %d %d", &flag, &banlevel, &bantype, &chmodeslevel,
					&bandefault, &limit_min, &limit_inc);
			}
			else if(!strcmp(buff1, "MOTD")) Strncpy(motd, field, TOPICLEN);
			else if(!strcmp(buff1, "URL")) /* on peut ainsi supprimer une ligne des DBs chans*/
			{
				Strncpy(chanurl, field, 100);
				cc = add_chan(chan, topic, description, defmodes, deftopic, welcome, motd, chanurl);
				if(!cc)
				{
					printf("Erreur lors du chargement de %s\n", chan);
					break;
				}
				else
				{
					cc->banlevel = banlevel;
					cc->flag = (flag & ~C_JOINED);
					cc->bantype = (bantype > 4 || bantype < 1) ? 1 : bantype;
					cc->cml = chmodeslevel;
					cc->bantime = (time_t) bandefault;
					cc->limit_min = limit_min;
					cc->limit_inc = limit_inc;
				}
			}
			else if(!strcmp(buff1, "SUSPEND") && *field)
			{ /* UserName TimeStamp :raison */
				char *from, *expire, *raison, *debut;
				raison = strchr(field, ':');
				from = strtok(field, " ");
				expire = strtok(NULL, " ");
				debut = strtok(NULL, " ");
				do_chan_suspend(cc, ++raison, from, strtol(expire, NULL, 10), strtol(debut, NULL, 10));
			}
		}
		fclose(fp1);
		snprintf(buff1, 230, DBDIR "/bans/%s", nchan);
		if(!(fp1 = fopen(buff1, "r"))) continue;
		buff1[0] = '\0';
		while(fgets(buff1, 500, fp1))
		{
			char *mask = NULL, *de = NULL, *debut = NULL, *fin = NULL, *level = NULL;
			strip_newline(buff1);
			tmp = strchr(buff1, ':');
			mask = strtok(buff1, " ");
			de = strtok(NULL, " ");
			debut = strtok(NULL, " ");
			fin = strtok(NULL, " ");
			level = strtok(NULL, " ");
			add_ban(cc, mask, ++tmp, de, atol(debut), atol(fin), atoi(level));
		}
		fclose(fp1);
	}
	fclose(fp);
	return stats;
}


void write_chans(void)
{
	aChan *chan = chanhead;

	for(;chan; chan = chan->next) write_achan(chan);
	return;
}


void write_badchans(void)
{
	FILE *fp;
	struct badchans *badchan;

	if(!(fp = fopen(BADCHANS_FILE, "w"))) return;

	for(badchan = badchead;badchan;badchan=badchan->next)
		fprintf(fp, "%s :%s\n", badchan->chaine, badchan->raison);

	fclose(fp);
	return;
}

int load_badchans(void)
{
   FILE *fp = fopen(BADCHANS_FILE, "r");
   char buff[300], *chaine, *raison = NULL;
   int stats = 0;

   if(!fp) return 0;
   while(fgets(buff, 300, fp))
   {
	   strip_newline(buff);
	   if((raison = strchr(buff, ':'))) *raison++ = '\0';
	   chaine = strtok(buff, " ");
	   add_abadchan(chaine, raison);
   }
   fclose(fp);
   return stats;
}

void write_badnicks(void)
{
	FILE *fp = fopen(BADNICKS_FILE, "w");
	struct badnicks *badnick;

	if(!fp) return;

	for(badnick = badnhead;badnick;badnick=badnick->next)
		fprintf(fp, "%s %d\n", badnick->chaine, badnick->flag);

	fclose(fp);
	return;
}

int load_badnicks(void)
{
	FILE *fp;
	char buff[100], *nick, *flag = NULL;
	int stats = 0;

	if(!(fp = fopen(BADNICKS_FILE, "r"))) return 0;

	while(fgets(buff, sizeof buff, fp))
	{
		int f = 0;
		strip_newline(buff);
		nick = strtok(buff, " ");
		flag = strtok(NULL, " ");
		if(flag && is_num(flag) && atoi(flag)) f |= CF_NOREG;
		add_abadnick(buff, f);
		stats++;
	}
	fclose(fp);
	return stats;
}

void write_cmds(void)
{
	FILE *fp = fopen(CMDS_FILE, "w");
	int i = 0;
	if(!fp) return;

	while(cs_cmds[i].cmd[0] != '\0')
	{
		if(cs_cmds[i].cmd[0] != '\001') fprintf(fp, "%s %s %d %d %d\n",
		  cs_cmds[i].realcmd[0] != '\0' ? cs_cmds[i].realcmd : cs_cmds[i].cmd,
		  cs_cmds[i].cmd, cs_cmds[i].level, cs_cmds[i].flag, cs_cmds[i].used);
		i++;
	}
	fclose(fp);
}

int load_cmds(void)
{
	FILE *fp, *f;
	char buff[250], realcmd[15], cmd[15], dir[50];
	int c = 0;

	if(!(fp = fopen(CMDS_FILE, "r"))) return 0;
	while(fgets(buff, 80, fp) != NULL)
	{
		int level = 0, flag = 0, used = 0, i = c;
		strip_newline(buff);
		sscanf(buff, "%14s %14s %d %d %d", realcmd, cmd, &level, &flag, &used);
		for(;cs_cmds[i].cmd[0] != '\0' && strcasecmp(cs_cmds[i].cmd, realcmd);i++);
		if(cs_cmds[i].cmd[0] != '\0')
		{
			char tmp[15] = {0};
			Strncpy(tmp, cs_cmds[i].cmd, 14);
			strupr(tmp);
			snprintf(dir, 50, "syntax/%s", tmp);
			if((f = fopen(dir, "r")))
			{
				fgets(buff, 250, f);
				Strncpy(cs_cmds[i].syntax, buff, sizeof buff -1);
				fclose(f);
			}
			strcpy(cs_cmds[i].cmd, cmd);
			strcpy(cs_cmds[i].realcmd, realcmd);
			cs_cmds[i].level = level;
			if(!flag || flag == CMD_DISABLE)
			{
				if(!flag) cs_cmds[i].flag &= ~(CMD_DISABLE | CMD_ADMIN);
				else cs_cmds[i].flag |= CMD_DISABLE;
			}
			else cs_cmds[i].flag = flag;
			cs_cmds[i].used = used;
			c++;
		}
	}
	fclose(fp);
	return c;
}

#ifdef HAVE_VOTE
void write_votes(void)
{
   FILE *fp = fopen(VOTE_FILE, "w");
   int i = 0;

   if(!fp) return;

   fprintf(fp, "VOTE %d %d :%s\n", vote_actif, vote_nbprop, vote_topic);
   for(;i<=vote_nbprop;i++) fprintf(fp, "PROP %d :%s\n", vote[i].voies, vote[i].prop);
   fclose(fp);
   return;
}

void load_votes(void)
{
   FILE *fp;
   char buff[300], *field = NULL, *tmp = NULL;
   int i = 0;

   if(!(fp = fopen(VOTE_FILE, "r"))) return;
   while(fgets(buff, sizeof buff, fp))
   {
	   strip_newline(buff);
	   if((field = strchr(buff, ' '))) *field++ = '\0';
	   if(!strcmp(buff, "VOTE") && field)
	   {
		   tmp = strchr(field, ':');
		   if(*tmp==':') tmp++;
		   Strncpy(vote_topic, tmp, MEMOLEN);
		   vote_actif = atoi(strtok(field, " "));
		   vote_nbprop = atoi(strtok(NULL, " "));
	   }
	   if(!strcmp(buff, "PROP") && field)
	   {
		   tmp = strchr(field, ':');
		   if(*tmp==':') tmp++;
		   Strncpy(vote[i].prop, tmp, MEMOLEN);
		   vote[i].voies = atoi(strtok(field, " "));
		   strcpy(vote[++i].prop, "end");
	   }
   }
   fclose(fp);
}
#endif /* HAVE_VOTE */

int write_files(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	write_users();
	write_userlist();
	write_chans();
	write_chanlist();
#ifdef USE_WELCOMESERV
	write_welcome();
#endif
	write_badchans();
	write_badnicks();
	write_cmds();
#ifdef HAVE_VOTE
	write_votes();
#endif
	csntc(nick, "Les fichiers ont bien t crits");
	return 1;
}

void append_file(const char *file, const char *ligne)
{
	FILE *fp = fopen(file,"a");
	if(fp)
	{
		fprintf(fp, "%s\n", ligne);
		fclose(fp);
	}
	return;
}
