/* src/memoserv.c - Diverses commandes sur le module memoserv
 * Copyright (C) 2002-2003 Inter System
 *
 * contact: Progs@Inter-System.Net
 *          Cesar@Inter-System.Net
 *          kouak@kouak.org
 * site web: http://coderz.inter-system.net
 *
 * Services pour serveur IRC. Support sur IrcProgs et IrCoderZ
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "main.h"

CVSINFO("$Id: memoserv.c,v 1.23 2003/07/24 13:06:34 romexzf Exp $");

#ifdef USE_MEMOSERV

void show_notes(aNick *nick)
{
	aMemo *memo = nick->user->memohead;
	int i = 0;
	for(;memo;memo=memo->next) if(!memo->read) i++;

	if(i) csntc(nick, "Vous avez reu\2 %d\2 nouveau%s memo%s, pour le%s lire tapez \2/%s %s LIRE <ALL|N du memo>\2",
			i, (i > 1) ? "x" : "", PLUR(i), PLUR(i), cs.nick, RealCmd("memos"));
	return;
}

int memos(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	aMemo *memo, *mt = NULL;
	int i = 0, p = 0, found = 0;
	const char *cmd = parv[1];

	if(!strcasecmp(cmd, "LIRE") || !strcasecmp(cmd, "READ"))
	{
		if(parc < 2) return csntc(nick, "Syntaxe : %s LIRE <NEW|ALL|N DU MEMO>", RealCmd("memos"));

		if(is_num(parv[2])) i = atoi(parv[2]);
		else if (!strcasecmp(parv[2], "ALL")) i = -1;
		else if (!strcasecmp(parv[2], "NEW")) i = -2;
		else return csntc(nick, "Syntaxe : %s LIRE <ALL|NEW|N DU MEMO>", RealCmd("memos"));

		for(memo=nick->user->memohead;memo;memo=memo->next)
		{
			p++;
			if(p == i || i == -1 || (i == -2 && !memo->read))
			{
				csntc(nick, "%c#%d De\2 %s\2 [%s] : %s", memo->read ? ' ' : '*', p, memo->de, get_time(memo->date), memo->message);
				found = memo->read = 1;
			}
		}
		if(found)
		{
			if(i == -1) csntc(nick, "Il y a\2 %d \2memo%s au total (Tapez /%s %s SUPPR ALL pour les supprimer)",
							p, PLUR(p), cs.nick, RealCmd("memos"));
			else if(i == -2) csntc(nick, "Il y a\2 %d\2 nouveau%s memo%s au total.", p, PLUR(p), PLUR(p));
			else csntc(nick, "Fin du memo n%d (Tapez /%s %s SUPPR %d pour le supprimer)", i, cs.nick, RealCmd("memos"), i);
		}
		else if (i < 0 && !found) csntc(nick, "Vous n'avez aucun %smemo.", (i == -2) ? "nouveau " : "");
		else csntc(nick, "Le memo n%d n'a pas t trouv", i);
	}
	else if(!strcasecmp(cmd, "SUPPRIMER") || !strcasecmp(cmd, "ERASE")
		|| !strcasecmp(cmd, "SUPR") || !strcasecmp(cmd, "SUPPR") || !strcasecmp(cmd, "DEL"))
	{
		if(parc < 2) return csntc(nick, "Syntaxe : %s SUPPR <ALL|N DU MEMO>", RealCmd("memos"));

		if(is_num(parv[2])) i = atoi(parv[2]);
		for(p = 1, memo = nick->user->memohead;memo;p++, mt = memo, memo = memo->next)
		{
			if(!i)
			{
				free(mt);
				found++;
			}
			else if(p == i)
			{
				if(mt) mt->next = memo->next;
				else nick->user->memohead = memo->next;
				free(memo);
				found = 1;
				break;
			}
		}
		if(!i && found)
		{
			free(mt);
			csntc(nick, "Vos\2 %d\2 memos ont bien t supprims.", found);
			nick->user->memohead = NULL;
		}
		else if (!i && !found) csntc(nick, "Il n'y a aucun memo");
		else if (found) csntc(nick, "Le memo n%d a bien t supprim", i);
		else csntc(nick, "Le memo n%d n'a pas t trouv", i);
		write_anuser(nick->user);
	}
	else if(!strcasecmp(cmd, "SEND") || !strcasecmp(cmd, "ENVOYER"))
	{
		anUser *user;
		aNick *who;
		char *tmp;

		if(parc < 3)
			return csntc(nick, "Syntaxe : %s ENVOYER <username> <message>", RealCmd("memos"));

		if(!(user = getuserinfo(parv[2])))
			return csntc(nick, NOSUCHUSER, parv[2]);

		if(!strcasecmp(user->nick, nick->user->nick))
			return csntc(nick, "Vous ne pouvez pas vous envoyer de memo.");

		if(UNoMemo(user) && !IsAnAdmin(nick->user))
			return csntc(nick, "%s n'accepte aucun memo.", user->nick);

		tmp = parv2msg(parc, parv, 3, MEMOLEN + 3);
		if(*tmp == ':') tmp++;

		if(strlen(tmp) > MEMOLEN)
			return csntc(nick, "Veuillez envoyer un memo plus court. (%d caractres max)", MEMOLEN);

		if((who = user->n) && !(who->flag & N_AWAY)) csntc(who, "\2MEMO DE %s@%s :\2 %s", nick->nick, nick->user->nick, tmp);

		for(memo = user->memohead;memo;memo = memo->next) if(!strcasecmp(memo->de,nick->user->nick)) i++;
		if(i >= MAXMEMOS && !IsAnAdmin(nick->user))
			return csntc(nick, "Vous avez dj envoy suffisament de mmos  %s. (MAX: %d)", user->nick, MAXMEMOS);

		add_memo(user, nick->user->nick, time(NULL), tmp, (who && !(who->flag & N_AWAY)) ? 1 : 0);
		csntc(nick, "Un memo a bien t envoy  \2%s\2.", user->nick);
		csntc(nick, "\2Texte:\2 %s", tmp);
		write_anuser(user);
	}
	else
	{
		csntc(nick, "La sous commande\2 %s\2 n'existe pas.", cmd);
		syntax_cmd(nick, GetCmdIndexbyName("MEMOS"));
		return 0;
	}
	return 1;
}
#endif
