/* src/opdeop.c - Fonctions de base chanserv (op, deop, voice, devoice, etc)
 * Copyright (C) 2002-2003 Inter System
 *
 * contact: Progs@Inter-System.Net
 *          Cesar@Inter-System.Net
 *          kouak@kouak.org
 * site web: http://coderz.inter-system.net
 *
 * Services pour serveur IRC. Support sur IrcProgs et IrCoderZ
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "main.h"

CVSINFO("$Id: opdeop.c,v 1.16 2003/08/02 01:56:02 romexzf Exp $");

int voice(aNick *, aChan *, int, char **);
int devoice(aNick *, aChan *, int, char **);
int deop(aNick *, aChan *, int, char **);
int op(aNick *, aChan *, int, char **);
int devoiceall(aNick *, aChan *, int, char **);
int voiceall(aNick *, aChan *, int, char **);
int deopall(aNick *, aChan *, int, char **);
int opall(aNick *, aChan *, int, char **);
int kickall(aNick *, aChan *, int, char **);
int kickbanall(aNick *, aChan *, int, char **);

int op(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	int i = 2, count = 0, nbnoco = 0;
	char buff[100] = {0}, mode[7] = {0}, *c = parv[1], noco[400] = {0};
	aNick *n;
	aJoin *chan;

	if(CNoOps(chaninfo))
		return csntc(nick, "Le NOOPS est actif sur %s", c);

	if(parc == 1)
	{
		if(!(chan = getjoininfo(nick,c)))
			return csntc(nick, "Vous n'tes pas sur %s", c);

		chan->is_op = 1;
		csmode(chaninfo, "+o %s", nick->numeric);
		return 1;
	}

	for(;i<=parc;i++)
	{
		if(!strcasecmp(parv[i], cs.nick)) continue;
		if(!(n = GetMemberIbyNick(chaninfo, parv[i])))
		{
			if(strlen(noco) >= (400-NICKLEN)) continue;
			if(noco[0] != '\0') strcat(noco, " ");
			strcat(noco, parv[i]);
			nbnoco++;
			continue;
		}
		chan = getjoininfo(n, c);
		if(chan->is_op) continue;
		chan->is_op = 1;
		strcat(mode, "o");
		sprintf(buff, "%s %s", buff, n->numeric);

		if(++count > 5)
		{
			csmode(chaninfo, "+%s %s", mode, buff);
			count = 0;
			buff[0] = '\0';
			mode[0] = '\0';
		}
	}

	if(nbnoco) csntc(nick, "%s n%s pas sur le salon", noco, (nbnoco == 1) ? "'est" : "e sont");
	if(count) csmode(chaninfo, "+%s %s", mode, buff);
	return 1;
}

int deop(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	int i = 2, count = 0, nbnoco = 0;
	char buff[100] = {0}, mode[7] = {0}, *c = parv[1], noco[400] = {0};
	aNick *n;
	aJoin *chan;

	if(parc == 1)
	{
		if(!(chan = getjoininfo(nick,c)))
			return csntc(nick, "Vous n'tes pas sur %s", c);

		chan->is_op = 0;
		csmode(chaninfo, "-o %s", nick->numeric);
		return 1;
	}

	for(;i<=parc;i++)
	{
		if(!strcasecmp(parv[i], cs.nick))
		{
			csntc(nick, "Merci de ne pas Deop %s", cs.nick);
			continue;
		}

		if(!(n = GetMemberIbyNick(chaninfo, parv[i])))
		{
			if(strlen(noco) >= (400-NICKLEN)) continue;
			if(noco[0] != '\0') strcat(noco, " ");
			strcat(noco, parv[i]);
			nbnoco++;
			continue;
		}
		if(n->flag & (N_GOD | N_OPER))
		{
			csntc(nick, "%s est IRCop.", n->nick);
			continue;
		}
		if(IsAnAdmin(n->user) && n->user->level > nick->user->level)
		{
			csntc(nick, "%s est Administrateur des Services.", n->nick);
			continue;

		}
		chan = getjoininfo(n, c);
		chan->is_op = 0;
		strcat(mode, "o");
		sprintf(buff, "%s %s", buff, n->numeric);
		if(++count > 5)
		{
			csmode(chaninfo, "-%s %s", mode, buff);
			count = 0;
			buff[0] = '\0';
			mode[0] = '\0';
		}
	}

	if(nbnoco) csntc(nick, "%s n%s pas sur le salon", noco, (nbnoco == 1) ? "'est" : "e sont");
	if(count) csmode(chaninfo, "-%s %s", mode, buff);
	return 1;
}

int opall(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	aLink *lp = NULL;
	char buf[60] = {0}, m[7] = {0};
	int i = 0;

	if(CNoOps(chaninfo))
		return csntc(nick, "Le NOOPS est actif sur %s", parv[1]);

	for(lp=chaninfo->members;lp;lp=lp->next)
		if(!lp->value.j->is_op)
		{
			strcat(m, "o");
			sprintf(buf, "%s %s", buf, lp->value.j->nick->numeric);
			lp->value.j->is_op = 1;
			if(++i > 5)
			{
				csmode(chaninfo, "+%s %s", m, buf);
				i = 0;
				buf[0] = '\0';
				m[0] = '\0';
			}
		}
	if(i && buf[0] != '\0') csmode(chaninfo, "+%s %s", m, buf);
	return 1;
}

int deopall(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	aLink *lp;
	aNick *n = NULL;
	char buf[150] = {0}, m[7] = {0};
	int i = 0;

	for(lp=chaninfo->members;lp;lp=lp->next)
		if(lp->value.j->is_op && (n=lp->value.j->nick) && (!(n->flag & N_OPER) && (!n->user || !IsAnAdmin(n->user) || n->user->level <= nick->user->level)))
		{
			strcat(m, "o");
			sprintf(buf, "%s %s", buf, lp->value.j->nick->numeric);
			lp->value.j->is_op = 0;
			if(++i > 5)
			{
				csmode(chaninfo, "-%s %s", m, buf);
				i = 0;
				buf[0] = '\0';
				m[0] = '\0';
			}
		}

	if(i) csmode(chaninfo, "-%s %s", m, buf);
	return 1;
}

int voice(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	int i = 2, count = 0, nbnoco = 0;
	char buff[100] = {0}, mode[7] = {0}, *c = parv[1], noco[400] = {0};
	aNick *n;
	aJoin *chan;

	if(parc == 1)
	{
		if(!(chan = getjoininfo(nick,c)))
			return csntc(nick, "Vous n'tes pas sur %s", c);

		csmode(chaninfo, "+v %s", nick->numeric);
		chan->is_voice = 1;
		return 1;
	}

	for(;i<=parc;i++)
	{
		if(!strcasecmp(parv[i], cs.nick)) continue;
		if(!(n = GetMemberIbyNick(chaninfo, parv[i])))
		{
			if(strlen(noco) >= (400-NICKLEN)) continue;
			if(noco[0] != '\0') strcat(noco, " ");
			strcat(noco, parv[i]);
			nbnoco++;
			continue;
		}
		chan = getjoininfo(n,c);
		if(chan->is_voice) continue;
		chan->is_voice = 1;

		strcat(mode, "v");
		sprintf(buff, "%s %s", buff, n->numeric);
		if(++count > 5)
		{
			csmode(chaninfo, "+%s %s", mode, buff);
			count = 0;
			buff[0] = '\0';
			mode[0] = '\0';
		}
	}
	if(nbnoco) csntc(nick, "%s n%s pas sur le salon", noco, (nbnoco == 1) ? "'est" : "e sont");
	if(count) csmode(chaninfo, "+%s %s", mode, buff);
	return 1;
}

int devoice(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	int i = 2, count = 0, nbnoco = 0;
	char buff[100] = {0}, mode[7] = {0}, *c = parv[1], noco[400] = {0};
	aNick *n;
	aJoin *chan;

	if(parc == 1)
	{
		if(!(chan = getjoininfo(nick,c)))
			return csntc(nick, "Vous n'tes pas sur %s", c);

		csmode(chaninfo, "-v %s", nick->numeric);
		chan->is_voice = 0;
		return 1;
	}

	for(;i<=parc;i++)
	{
		if(!(n = GetMemberIbyNick(chaninfo, parv[i])))
		{
			if(strlen(noco) >= (400-NICKLEN)) continue;
			if(noco[0] != '\0') strcat(noco, " ");
			strcat(noco, parv[i]);
			nbnoco++;
			continue;
		}

		chan = getjoininfo(n, c);
		if(!chan->is_voice) continue;
		chan->is_voice = 0;
		strcat(mode, "v");
		sprintf(buff, "%s %s", buff, n->numeric);
		if(++count > 5)
		{
			csmode(chaninfo, "-%s %s", mode, buff);
			count = 0;
			buff[0] = '\0';
			mode[0] = '\0';
		}
	}
	if(nbnoco) csntc(nick, "%s n%s pas sur le salon", noco, (nbnoco == 1) ? "'est" : "e sont");
	if(count) csmode(chaninfo, "-%s %s", mode, buff);
	return 1;
}

int voiceall(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	aLink *lp = NULL;
	char buf[60] = {0}, m[7] = {0};
	int i = 0;

	for(lp=chaninfo->members;lp;lp=lp->next)
		if(!lp->value.j->is_voice)
		{
			strcat(m, "v");
			sprintf(buf, "%s %s", buf, lp->value.j->nick->numeric);
			lp->value.j->is_voice = 1;
			if(++i > 5)
			{
				csmode(chaninfo, "+%s %s", m, buf);
				i = 0;
				buf[0] = '\0';
				m[0] = '\0';
			}
		}
	if(i && buf[0] != '\0') csmode(chaninfo, "+%s %s", m, buf);
	return 1;
}

int devoiceall(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	aLink *lp = NULL;
	char buf[60] = {0}, m[7] = {0};
	int i = 0;

	for(lp=chaninfo->members;lp;lp=lp->next)
		if(lp->value.j->is_voice)
		{
			strcat(m, "v");
			sprintf(buf, "%s %s", buf, lp->value.j->nick->numeric);
			lp->value.j->is_voice = 0;
			if(++i > 5)
			{
				csmode(chaninfo, "-%s %s", m, buf);
				i = 0;
				buf[0] = '\0';
				m[0] = '\0';
			}
		}
	if(i && buf[0] != '\0') csmode(chaninfo, "-%s %s", m, buf);
	return 1;
}

int kickall(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	aLink *lp;
	aNick *n = NULL;
	char r[180];

	if(parc < 2) strcpy(r, DEFRAISON);
	else parv2msgn(parc,parv,2, r, 180);

	for(lp=chaninfo->members;lp;lp=lp->next)
		if((n = lp->value.j->nick) && n != nick && (!(n->flag & N_OPER) && (!n->user || !IsAnAdmin(n->user) || n->user->level <= nick->user->level)))
			cskick(chaninfo->chan, n->numeric, "%s", r);
	return 1;
}

int kickbanall(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	aLink *lp;
	aNick *n = NULL;
	char r[180], *mask;

	if(parc < 2)
		return csntc(nick, "Veuillez prciser une raison.");

	parv2msgn(parc,parv,2, r, 180);
	for(lp=chaninfo->members;lp;lp=lp->next)
		if((n=lp->value.j->nick) && n != nick && (!(n->flag & N_OPER) && (!n->user || !IsAnAdmin(n->user) || n->user->level <= nick->user->level)))
		{
			mask = getbanmask(n, chaninfo->bantype);
			add_ban(chaninfo, mask, r, nick->user->nick, time(NULL), 0, 0);
			csmode(chaninfo, "+b %s", mask);
			cskick(chaninfo->chan, n->numeric, "%s", r);
		}
	return 1;
}
